#include <openssl/des.h>
#include <string.h>
#include <qstring.h>

#include "hash.h"

int normalize_buffer_size(const char *in, char **out, unsigned int input_size)
{
  unsigned int i;

  if ((input_size%8)==0)
    {
      *out = (char *)malloc(input_size);
      memcpy(*out,in,input_size);
      return input_size;
    }
  else
    {
      *out = (char *)malloc(input_size-(input_size%8)+8);
      memcpy(*out,in,input_size);
      for (i=0;i<8-(input_size%8);i++)
	{
	  (*out)[input_size+i]='\n';
	}
      return input_size-(input_size%8)+8;
    }
}

void des_crypt_buff(const char *in,char *out, unsigned int size, DES_key_schedule key)
{
  unsigned int pos = 0;
  char temp1[8];
  char temp2[8];

  while((size - pos) >= 8)
    {
      memcpy(temp1,in+pos,8);
      DES_ecb_encrypt((DES_cblock *)temp1, (DES_cblock *)temp2, &key, DES_ENCRYPT);
      memcpy(out+pos,temp2,8);
      pos+=8;
    }
}

void des_decrypt_buff(char *in,char *out, unsigned int size, DES_key_schedule key)
{
  unsigned int pos = 0;
  char temp1[8];
  char temp2[8];

  while((size - pos) >= 8)
    {
      memcpy(temp1,in+pos,8);
      DES_ecb_encrypt((DES_cblock *)temp1, (DES_cblock *)temp2, &key, DES_DECRYPT);
      memcpy(out+pos,temp2,8);
      pos+=8;
    }
}

void print_data_buff(const char *buff, unsigned int size)
{
  unsigned int i;

  for (i=0;i<size;i++)
    {
      printf("%02X ",(unsigned char)buff[i]);
    }
  printf("\n");
}

void generate_key_from_string(QString netkey, DES_ks *res)
{
  DES_cblock temp;

  DES_string_to_key(netkey.latin1(),&temp);
  DES_set_key(&temp,res);

}

DES_cblock *generate_random_key()
{
  DES_cblock *cle;
  cle = (DES_cblock *)malloc(sizeof(DES_cblock));
  DES_random_key(cle);
  return cle;
}
