/***************************************************************************
 *            hash.cpp
 *
 *  Sat Mar 26 13:18:45 2005
 *  Copyright  2004  Francois Goudal
 *  francois@goudal.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qapplication.h>
#include <openssl/md5.h>
#include <openssl/sha.h>

int md5_buffer_hash(const unsigned char *in, unsigned long int len, unsigned char *out)
{
  MD5(in,len,out);
  return 0;
}

int sha_buffer_hash(const unsigned char *in, unsigned long int len, unsigned char *out)
{
  SHA1(in,len,out);
  return 0;
}

int md5_filepart_hash(const char *filename,unsigned long int start, unsigned long int length, unsigned char *res)
{
  int j;
  char *temp;
  FILE * fd;

  MD5_CTX md4c;

  fd = fopen(filename,"rb");
  fseek(fd,start,SEEK_SET);
  if (fd == NULL)
    {
      qDebug("MD5 : Fichier Introuvable");
      return 1;
    }

  MD5_Init(&md4c);
  temp = (char *)malloc(4096);
  while ((length)&&((j = (int) fread(temp, 1, 4096, fd)) > 0))
    {
      MD5_Update(&md4c, temp, (unsigned) j);
      length-=j;
    }
  free(temp);
  MD5_Final(res, &md4c);

  fclose(fd);

  return 0;
}

void bin2hex_hash(const unsigned char *src, char *dest)
{
  int i;
  char temp[3];

  dest[0]=0;
  for (i=0;i<MD5_DIGEST_LENGTH;i++)
    {
      sprintf(temp,"%02X",src[i]);
      strcat(dest,temp);
    }
}

void hex2bin_hash(const char *src, char *dest)
{
	unsigned int t;
	char tmp[3];
	tmp[2]=0;
	for (int i=0;i<MD5_DIGEST_LENGTH;i++)
	{
		memcpy(tmp,src+2*i,2);
		sscanf(tmp,"%02X",&t);
		dest[i]=(char)t;
	}
}
