/***************************************************************************
 *            hash.h
 *
 *  Sat Mar 26 13:18:45 2005
 *  Copyright  2004  Francois Goudal
 *  francois@goudal.net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _HASH_H_
#define _HASH_H_

#include <openssl/md5.h>
#include <openssl/sha.h>

int md5_filepart_hash(const char *filename,unsigned long int start, unsigned long int length, unsigned char *res);
int md5_buffer_hash(const unsigned char *in, unsigned long int len, unsigned char *out);
int sha_buffer_hash(const unsigned char *in, unsigned long int len, unsigned char *out);
void bin2hex_hash(const unsigned char *src, char *dest);
void hex2bin_hash(const char *src, char *dest);

#endif
