/****************************************************************************
 *            ghashfile.cpp
 *
 *  Sat Mar 26 18:51:36 2005
 *  Copyright  2005  CrYpToNyM
 *  crypt0nym@sf.net

 ATTENTION :
 CE FICHIER NE FONCTIONNE PAS EN BIG ENDIAN ... ou pas :)


 ****************************************************************************/

#include <stdlib.h>
#include "ghashfile.h"

GHashFile::GHashFile()
{
	chunkHashes=NULL;
	StopHashing = FALSE;
}

GHashFile::~GHashFile()
{
	free(chunkHashes);
}

void GHashFile::stopHashing()
{
	StopHashing = TRUE;
}

bool GHashFile::readFromFile(const QString &filepath)
{
	//unsigned char hash[MD5_DIGEST_LENGTH];
	char c[MD5_DIGEST_LENGTH*2 +1];
	unsigned long int start=0,len,i;
	unsigned int nbh;

	free(chunkHashes);
	chunkHashesTxt.clear();
	QFileInfo inf(filepath);
	fileSize=inf.size();
	fileName=inf.fileName();
	modDate=inf.lastModified();

	if (!inf.isReadable())
		return false;

	if (CHUNK_SIZE>fileSize)
	{ //Gestion de l'echec
		if (!fileSize)
			return false;
		len=fileSize;
	} else
		len=CHUNK_SIZE;

	nbh=getChunkNum();
	chunkHashes = (unsigned char *) malloc(MD5_DIGEST_LENGTH*nbh);
	i=0;

	while (nbh>1 && !StopHashing)
	{
		if (md5_filepart_hash(filepath.latin1(),start,len,chunkHashes+i))
		{ //Gestion de l'echec
			free(chunkHashes);
			return false;
		}
		bin2hex_hash(chunkHashes+i, c);
		chunkHashesTxt.append(QString(c));
		i+=MD5_DIGEST_LENGTH;
		start+=CHUNK_SIZE;
		--nbh;
	}

	if (start<fileSize && !StopHashing) //dernier chunk (plus petite taille)
	{
		len=fileSize-start;
		if (md5_filepart_hash(filepath.latin1(),start,len,chunkHashes+i))
		{ //Gestion de l'echec
			free(chunkHashes);
			return false;
		}
		bin2hex_hash(chunkHashes+i, c);
		chunkHashesTxt.append(QString(c));
	}

	//Si on arrive ici alors le tableau de hash est rempli
	//on a plus qu'a calculer le hash final
	if(!StopHashing)
	{
		md5_buffer_hash(chunkHashes,getChunkNum()*MD5_DIGEST_LENGTH,fileHash);
		bin2hex_hash(fileHash,c);
		fileHashTxt = QString(c);
	}

	return true;
}

QDateTime& GHashFile::getModDate()
{
	return modDate;
}
unsigned long int GHashFile::getFileSize()
{
	return fileSize;
}
QString& GHashFile::getFileName()
{
	return fileName;
}
QString& GHashFile::getFileHash()
{
	return fileHashTxt;
}
QString& GHashFile::getChunkHash(unsigned int part)
{
	return chunkHashesTxt[part];
}
unsigned int GHashFile::getChunkNum()
{
	return (fileSize+CHUNK_SIZE-1)/CHUNK_SIZE;
}

const unsigned char *GHashFile::getBinChunkHash(unsigned int chunk)
{
	return (unsigned char *)chunkHashes+chunk*MD5_DIGEST_LENGTH;
}
