/****************************************************************************
 *            ghashfile.h
 *
 *  Sat Mar 26 17:03:39 2005
 *  Copyright  2005  CrYpToNyM
 *  Email - crypt0nym@sf.net
 ****************************************************************************/

#ifndef _GHASHFILE_H
#define _GHASHFILE_H

#include "../crypt/hash.h"
#include <qstring.h>
#include <qvaluevector.h>
#include <qfileinfo.h>
#include "gfileconst.h"


//typedef QValueVector<unsigned char[MD5_DIGEST_LENGTH]> HashVector;
typedef unsigned char* HashVector;

class GHashFile
{
	public :
	GHashFile();
	~GHashFile();

	//Stop le hachage en cours
	void stopHashing();

	//Recuperation des infos
	bool readFromFile(const QString &filepath);

	//Manipulation des champs independamment
	QDateTime& getModDate();
	unsigned long int getFileSize();
	QString& getFileName();
	QString& getFileHash();
	QString& getChunkHash(unsigned int chunk);
	unsigned int getChunkNum();

	//En binaire
	const unsigned char *getBinChunkHash(unsigned int chunk);

	private :
	QDateTime modDate;
	QString fileName;
	unsigned char fileHash[MD5_DIGEST_LENGTH];
	QString fileHashTxt;
	QValueVector<QString> chunkHashesTxt;
	unsigned long int fileSize;
	HashVector chunkHashes;

	bool StopHashing;
};


#endif /* _GHASHFILE_H */
