/***************************************************************************
 *            guploader.h
 *
 *  Mon May  9 15:49:19 2005
 *  Copyright  2005  CrYpToNyM
 *  Email
 ****************************************************************************/

#ifndef _GUPLOADER_H
#define _GUPLOADER_H

#include <qfile.h>
#include <qstring.h>
#include <qvaluevector.h>
#include <qbitarray.h>
#include <qptrvector.h>

#include "gtempfile.h"
#include "../network/gfileulsocket.h"
#include "../crypt/gcryptsocket.h"


struct s_ofile
{
	QFile *f;
	Q_UINT64 size;
	QString hash;
	QValueVector <QString> chunk_hash;
	QBitArray chunks;
	Q_UINT16 nbopen;
};
	
class GUploader : public QObject
{
	Q_OBJECT
	
	public:
		GUploader(Q_UINT16 uspeed, Q_UINT16 nbslot, QValueVector <GTempFile*> *tmpfilevect,QObject * parent=0,const char * name=0);
		~GUploader();

	public slots:
		/* Le GNetwork nous envoie du travail */
		void incomingUl(const QString &nodeid,GCryptSocket *s);
		void outgoingUl(const QString &nodeid,const QString &ip, Q_UINT16 port);
	
		/* L'interface nous demande de changer de vitesse */
		void setUlSpeed(Q_UINT16);
		/* Changer le nombre de slots */
		void setNbSlots(Q_UINT16 n);
	
	signals:
		void connection(const QString &nodeid);
		void askingFile(Q_UINT64 fsize, const QString &hash, const QString &fname, const QString &nodename);
		void Transferring(Q_UINT64 fsize, const QString &hash, const QString &nodename, unsigned long int speed);
		void connectionLost(const QString &hash, Q_UINT64 fsize, const QString &nodename);
	
	private slots:
		/* Un socket nous demande son fichier */
		void askingFile(const char *hash,Q_UINT64 size);
		void getPart(unsigned int chunk, unsigned char part);
		void sockClose();
		void calcSpeed();
		void startSocket(GFileUlSocket *s);
	
	private:
		int addToOpenedFiles(s_ofile &ofile);
		Q_UINT16 speed,nbslots;
		QTimer *timer;
		QValueVector <s_ofile> open_files;
		QValueVector <GTempFile*> *temp_files;
		QPtrVector <GFileUlSocket> socket;
		QPtrList <GFileUlSocket> queue;
};

#endif /* _GUPLOADER_H */
