/****************************************************************************
 *            xmlparser.c
 *
 *  Tue Apr 19 21:09:32 2005
 *  Copyright  2005  z
 *  z@zzteam.net
 ****************************************************************************/

#include "xmlparser.h"
#include "qsharelist.h"
#include <iostream>
#include <qstring.h>
#include <qfileinfo.h>


Xmlparser::Xmlparser(QSharelist * sl)
{
	sharelist = sl;
	mode = xmlLoad;
}

Xmlparser::Xmlparser(const QString& h,Q_UINT64 s, QStringList * result)
{
	hash = h;
	size = s;
	mode = xmlPartHash;
	partHashes = result;
}

Xmlparser::Xmlparser(QStringList * result)
{
	mode = xmlPartHashFileList;
	partHashes = result;
}

/* Description :
		Action a realiser lorsqu'on rencontre une balise ouvrante
*/
bool Xmlparser::startElement( const QString&, const QString&,const QString& qName,const QXmlAttributes& atts)
{
	switch(mode)
	{
		default :
		case xmlLoad :
			if(qName == "file")
			{
				QString path = atts.value("path");
				QFileInfo f(path);
				if(f.exists())
					sharelist->filelist[atts.value("type").toInt()].insert(atts.value("hash"),path);
			}
			break;
				
		case xmlPartHash :
			if((qName == "file") && (atts.value("hash") == hash) && (atts.value("size").toULongLong() == size))
				for(int i=0;i<(atts.count()-ATTRIB_WO_PCHUNK);++i)
					(*partHashes) << atts.value("p"+QString::number(i));			
			break;
				
		case xmlPartHashFileList :
			if(qName == "hashes")
			{
				for(int i=0;i<atts.count()-1;++i)
				{
					(*partHashes) << atts.value("p"+QString::number(i));			
				}
			}
			break;
	}
	
  return TRUE;
}
