#include "xmltempfile.h"
#include "gtempfile.h"

/* cas ou le fichier existe deja  */
xmlTempFile::xmlTempFile(GTempFile * file)
{
	nb = 0;
	tmpFile = file;
}

bool xmlTempFile::startDocument()
{
		return TRUE;
}

bool xmlTempFile::startElement( const QString&, const QString&,
																		const QString& qName,
																		const QXmlAttributes& attrib)
{
		if (qName == "file")
		{
			unsigned int nbchunk = (attrib.value("size").toULongLong()+CHUNK_SIZE-1)/CHUNK_SIZE;
			qDebug("Nombre de chunk : " + QString::number(nbchunk));
			tmpFile->dlingChunks.resize(nbchunk);
			tmpFile->emptyChunks.resize(nbchunk);
			tmpFile->chunkSourceList.resize(nbchunk);
			tmpFile->chunks.resize(nbchunk);
			xf = tmpFile->xml->createElement("file");
			xf.setAttribute("name",(tmpFile->filename = attrib.value("name")));	
			xf.setAttribute("size",(tmpFile->filename = attrib.value("size")));	
			xf.setAttribute("hash",(tmpFile->filehash = attrib.value("hash")));
			xf.setAttribute("isDownloading",attrib.value("isDownloading"));
			xf.setAttribute("nodeid",attrib.value("nodeid"));
			tmpFile->isdownloading = attrib.value("isDownloading");
			xf.setAttribute("priority",attrib.value("priority"));
			tmpFile->xml->appendChild(xf);
			tmpFile->filesize = attrib.value("size").toULongLong();
			tmpFile->filetype = attrib.value("type").toUInt();
			tmpFile->nodeid = attrib.value("nodeid");
			return TRUE;
		}
		if(qName == "chunk")
		{
				QString state;
				tmpFile->chunks[nb] = tmpFile->xml->createElement("chunk");
				tmpFile->chunks[nb].setAttribute("n",attrib.value("n"));
				tmpFile->chunks[nb].setAttribute("hash",attrib.value("hash"));
				tmpFile->chunks[nb].setAttribute("count",attrib.value("count"));
				state = attrib.value("state");
				if(state == "2")
					tmpFile->chunkLeft -= 1;
				else
				{
					state = "0";
					tmpFile->chunkLeft += 1;
				}
				tmpFile->chunks[nb].setAttribute("state",state);
				xf.appendChild(tmpFile->chunks[nb]);
			
				return TRUE;
		}
		if(qName == "part")
		{
				QDomElement part;
				QString state;
				part = tmpFile->xml->createElement("part");
				for(int j=0;j<attrib.count();++j)
				{
					state = attrib.value("p"+QString::number(j));
					if(state == "0" || state == "1")
					{
						state = "0";
						tmpFile->emptyChunks[nb] << j;
					}
					part.setAttribute("p"+QString::number(j),state);
				}
				tmpFile->chunks[nb].appendChild(part);
				nb++;
				return TRUE;
		}
		return TRUE;
}


bool xmlTempFile::endElement( const QString&, const QString&, const QString& )
{
		return TRUE;
}
