#include "gdate.h"

QString GDate::timestamp()
{
  QString ts;
  QDateTime dt = QDateTime::currentDateTime();

  if (gconf->isCustomTimeStamp())
    {
      ts = gconf->timeStampString();
      ts.replace("%H",QString::number(dt.time().hour()));
      if (dt.time().hour()>12)
        {
          ts.replace("%h",QString::number(dt.time().hour()-12));
          ts.replace("%A","PM");
        }
      else
        {
          ts.replace("%h",QString::number(dt.time().hour()));
          ts.replace("%A","AM");
        }
      ts.replace("%M",QString::number(dt.time().minute()));
      ts.replace("%s",QString::number(dt.time().second()));
      ts.replace("%y",QString::number(dt.date().year()));
      ts.replace("%m",QString::number(dt.date().month()));
      ts.replace("%d",QString::number(dt.date().day()));
      switch (dt.date().dayOfWeek())
        {
        case 1:ts.replace("%D","Lundi");
        case 2:ts.replace("%D","Mardi");
        case 3:ts.replace("%D","Mercredi");
        case 4:ts.replace("%D","Jeudi");
        case 5:ts.replace("%D","Vendredi");
        case 6:ts.replace("%D","Samedi");
        case 7:ts.replace("%D","Dimanche");
        }
    }
  else
    {
      ts = QString::number(dt.time().hour())+":"+QString::number(dt.time().minute())+":"+QString::number(dt.time().second())+" - ";
    }
  return ts;
}
