#include "glanguage.h"

void GLanguage::setAppLanguage()
{
	QTranslator * translator;	
	QString locale;	

	locale = findTraductionFile(gconf->language());
	if(locale == QString::null)
		locale = findTraductionFileByLocale();
	translator = new QTranslator;
	if(translator->load(gconf->applicationDirPath() + locale))
	{
		qApp->installTranslator( translator );
		gconf->setTranslator(translator);
	}
	else
		qWarning("Warning : the translation file doesn't exists or the language configuration is bad! Please check your Gloster directory and your configuration file.");
}

const QString GLanguage::findLanguage()
{
	QString locale;
	QTranslator translator;
	
	locale = findTraductionFileByLocale();
	translator.load(gconf->applicationDirPath() + locale);
	return translator.findMessage("MainWin","LOCALNAME").translation();
}

QStringList GLanguage::listLanguage()
{
    	QDir dir(gconf->applicationDirPath());
    	QStringList l,result;
	QTranslator translator;

	dir.setFilter( QDir::Files | QDir::NoSymLinks );
    	dir.setSorting( QDir::Name );
   	l = dir.entryList();
    	for ( QStringList::Iterator it = l.begin(); it != l.end(); ++it )
    	{
		if((*it).contains("gloster_",FALSE) && (*it).contains(".qm",FALSE))
		{
		    translator.load(*it);
		    result << translator.findMessage("MainWin","LOCALNAME").translation();
		}
    	}

	return result;
}

const QString GLanguage::findTraductionFile(const QString& langSettings)
{
	QDir dir(gconf->applicationDirPath());
	QStringList l;
	QTranslator translator;
	QString locale;
	
	dir.setFilter( QDir::Files | QDir::NoSymLinks );
	dir.setSorting( QDir::Name );
	l = dir.entryList();

	QStringList::Iterator it = l.begin();
	while(it != l.end() && locale==QString::null)
	{
			if((*it).contains("gloster_",FALSE) && (*it).contains(".qm",FALSE))
			{
				translator.load(*it);
				if(translator.findMessage("MainWin","LOCALNAME").translation()==langSettings)
					locale = (*it);
			}
			++it;
	}
	return locale;
}

const QString GLanguage::findTraductionFileByLocale()
{
		QDir d;
		QString locale=QTextCodec::locale();
		if(d.exists(gconf->applicationDirPath()+"gloster_"+locale+".qm"))
			return "gloster_"+locale+".qm";
		
		locale = locale.section("_",0);
		if(d.exists(gconf->applicationDirPath()+"gloster_"+locale+".qm"))
			return "gloster_"+locale+".qm";
		
		return "gloster_en.qm";
}

void GLanguage::changeLanguage()
{
	QTranslator * translator = new QTranslator;	

	qApp->removeTranslator(gconf->translator());
	if(translator->load(gconf->applicationDirPath() + findTraductionFile(gconf->language())))
	{
		qApp->installTranslator( translator );
		gconf->setTranslator(translator);
	}
	else
		qWarning("Warning : the translation file doesn't exists or the language configuration is bad! Please check your Gloster directory and your configuration file.");
}
