/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qcolor.h>
#include "../network/gnetwork.h"
#include "connex.h"
#include "../gconfig.h"
#include "../gdate.h"

extern GConfig * gconf;
extern GNetwork *net;

void chanwin::envoimsg()
{
    if (msgedt->text()!="")
    {
	net->sendChatMsg(caption(),msgedt->text());
	discuss->setColor(QColor(255,0,0));
        if (gconf->isChanTimeStamp())
	    discuss->append(GDate::timestamp()+gconf->nickname()+": "+msgedt->text());
        else
          discuss->append(gconf->nickname()+": "+msgedt->text());
	msgedt->clear();
    }
}

void chanwin::rcvmsg(const QString &sender, const QString &channame, const QString &msg)
{
  if (channame==caption())
    {
      if (gconf->isChanTimeStamp())
	  discuss->append(GDate::timestamp()+sender + ": " + msg);
      else
        discuss->append(sender + ": " + msg);
    }
}

void chanwin::userevt(const QString &name,const QString &channame, bool connexion)
{
  unsigned int i;

  if ((channame)==caption())
  {
      if (connexion)
      {
	  userlst->insertItem(name,-1);
	  userlst->sort(true);
      }
      else
      {
	  for(i=0;i<userlst->count();i++)
	  {
	      userlst->setSelected(i,true);
	      if ((userlst->currentText ())==name)
		  break;
	  }
	  if (i!=userlst->count())
	      userlst->removeItem(i);
      }
  }
}



void chanwin::destroy(  )
{
    net->sendChatUserEvent(caption(), false);
    QWidget::destroy();
}


void chanwin::init()
{
    setIcon(QPixmap::fromMimeSource("users.png"));
    msgedt->setFocus();
    connect(net,SIGNAL(recvChatMsg( const QString&, const QString&, const QString& )),this, SLOT(rcvmsg(const QString&, const QString&, const QString&)));
    connect(net,SIGNAL(recvChatUserEvent(const QString&,const QString&, bool)),this,SLOT(userevt(const QString&, const QString&, bool)));
}


bool chanwin::event( QEvent * e )
{
    bool b;
    QEvent::Type t = e->type();
    b = QWidget::event(e);
    if( t == QEvent::LanguageChange)
	setCaption(name);
    return b;
}


void chanwin::setName( const QString & str )
{
    name = str;
    setCaption(str);
}
