/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include "../network/gnetwork.h"
#include "../gui/filelist/qsharefileview.h"
#include "connex.h"
#include <qworkspace.h>
#include <qsplitter.h>
#include <qmessagebox.h>

extern GNetwork *net;

class ListViewUser : public QListViewItem
{
public :
	ListViewUser(QListView * parent, const QString &nick, Q_UINT16 id ):QListViewItem(parent,nick),UId(id)  {}
inline Q_UINT16 uid() { return UId; };

private :
	Q_UINT16 UId;
};

void contactlst::sndmsg()
{
    ListViewUser * item = (ListViewUser *) cntlst->selectedItem();
    if (item)
	emit sndpvmsg(item->text(0),item->uid());   
}



void contactlst::deluser(Q_UINT16 id)
{    
   QListViewItem* liste=cntlst->firstChild();
    while ((liste) &&  ((( ListViewUser*) liste)->uid()!=id))
	liste=liste->nextSibling();  

    delete liste;  
}


void contactlst::adduser( Q_UINT16 uid, const QString &nick, t_connexion contype)
{  
   QListViewItem* lv;  
   lv = new ListViewUser(cntlst, nick, uid);
   switch (contype)
      {
	 case 1 : 
	 case 2 :
	     lv->setPixmap(0,QPixmap::fromMimeSource("con1.png"));
	     break;	     
	 case 3 : 
	     lv->setPixmap(0,QPixmap::fromMimeSource("con2.png"));
	     break;	     
	 case 4 : 
	 case 5 :
	     lv->setPixmap(0,QPixmap::fromMimeSource("con3.png"));
	     break;		     
	 case 6 : 
	 case 7 :
	     lv->setPixmap(0,QPixmap::fromMimeSource("con4.png"));
	     break;		     
	 case 8 :
	     lv->setPixmap(0,QPixmap::fromMimeSource("con5.png"));
	     break;
      }
}

void contactlst::showmenu(QListViewItem *it,const QPoint &p,int)
{
    if (it)
    {
	QPopupMenu *menu = new QPopupMenu(cntlst,tr("menu"));
	menu->insertItem(QPixmap::fromMimeSource("fileshare.png"),tr("Voir les fichiers"),this,SLOT(openexplore()),0,0);
	menu->insertSeparator();
	menu->insertItem(QPixmap::fromMimeSource("key.png"),tr("Demander la cl"),this,SLOT(askkey()),0,1);
	menu->setItemVisible(0,TRUE); 
	menu->setItemVisible(1,FALSE); 
	menu->exec(p);  
    }
}

void contactlst::askkey()
{    
    if(ListViewUser * ls= (ListViewUser *) cntlst->selectedItem()) 
	net->sendKeyRequest(ls->uid());
}

void contactlst::openexplore()
{
    ListViewUser * liste= (ListViewUser * ) cntlst->selectedItem();
    
    if(gconf->pubKey(net->GetGraph()->nodes(liste->uid()).nodeid )==QString::null)
    {	
	if(gconf->autoAcceptKey() || QMessageBox::question(this, tr("Cl publique absente"),tr("Vous n'avez pas la cl publique de ce contact. Voulez vous la rcuprer?"), tr("Non"),tr("Oui") , QString::null, 0, 1 ))
	askkey();
    }
    else
	emit oexp(liste->uid());
}



void contactlst::hidewin()
{
  if   (cacher->text()==">")
   {
      
      cacher->setText("<");
      setMinimumSize(QSize(2,2));
      splitter4->setHidden(true);
      cntlbl->setHidden(true);
      chanlbl->setHidden(true);
      cntico->setHidden(true);
      chanico->setHidden(true);
      emit hidedock(true); 
  }
  else
  {
      cacher->setText(">");
      splitter4->setHidden(false);
      cntlbl->setHidden(false);
      chanlbl->setHidden(false);
      cntico->setHidden(false);
      chanico->setHidden(false);
      emit hidedock(false);    
  }
}


// concerne les chans

void contactlst::initLst()
{
    if (net)
    {
    unsigned int i;
     for(i=0;i<(net->chanlist.nb_chans);i++)   
       chanlst->insertItem(*(net->chanlist.chans[i].chan),-1);   
 }
}

void contactlst::Updatelst( const QString &name, bool creation) 
{  
    unsigned  int i;
    if (creation)
    {
	chanlst->insertItem(name,-1);
	i=chanlst->count()+1;
    }
    else
	for (i=0;i<chanlst->count();i++)
	    if (name==chanlst->text(i))
		break;
    
    if (i<chanlst->count())
	chanlst->removeItem(i);    
}


void contactlst::joindblclk(QListBoxItem* chan)
{     
    if ((net)) 
    {	
	if (!((chan->text()).isNull()) ) 
	{	
	    emit rejoindre( chan->text());
	}	   	
    }
}



void contactlst::init()
{
    initLst();
    cntico->setPixmap(QPixmap::fromMimeSource("users.png")); 
    chanico->setPixmap(QPixmap::fromMimeSource("chat.png")); 
    
    connect(net,SIGNAL(newNode(Q_UINT16, const QString&,t_connexion)),this, SLOT(adduser(Q_UINT16, const QString&,t_connexion)));
    connect(net,SIGNAL(delNode(Q_UINT16)),this, SLOT(deluser(Q_UINT16)));
    connect(net,SIGNAL(recvChatChanEvent( const QString&, bool)),this, SLOT(Updatelst( const QString&, bool)));
}
