/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qlabel.h>
#include <qcombobox.h>
#include <qfiledialog.h>
#include <qmessagebox.h>
#include <qstatusbar.h>
#include <qtranslator.h>
#include <qapplication.h>
#include <qpopupmenu.h>
#include <qlistbox.h>
#include "mainwin.h"
#include "../crypt/crypt_rsa.h"
#include "../crypt/crypt_des.h"
#include "../gconfig.h"
#include "../files/qsharelist.h"
#include "../glanguage.h"

extern GConfig * gconf;
extern QSharelist * shareList;

void config::writeSettings()
{
    QString pass;
    QListViewItem *it= keylst->firstChild();
    QDir d;

     if (check_key_pair(pubkey->text(),privkey->text()))
    {
	 gconf->setNickname(nickedt->text());
	 gconf->setNetKey(netkey->text());
	 gconf->setLanguage(lang->currentText());
	 GLanguage::changeLanguage();
	 gconf->setSplashScreen(spla->isChecked());
	 gconf->setTextUnderIcons(textundericonCheckBox->isChecked());

	 gconf->setSlotCount(nbrslots->value());
	 gconf->setAutoCon(autocon->isChecked());
	 gconf->setConType(cnxtype->count()-cnxtype->currentItem());
	 gconf->setConSpeed(cnxspeed->text().toInt());
	 gconf->setListenPort(listenport->value());
	 gconf->setPublicIp(pubip->text());
	 gconf->setKeepCon(keep->value());

	 gconf->setAutoRefreshShares(refreshAuto->isChecked());
	 gconf->setAutoRefreshUnit(refreshUnit->currentItem());
	 gconf->setAutoRefreshDelay(refreshTime->value());
	 if(!gconf->setDownloadDir(dlpath->text()))
	 {
	     QMessageBox::warning(this,trUtf8("Répertoire de destination invalide"),trUtf8("Impossible de lire ou de créer le répertoire de destination. Veuillez en choisir un autre."),QMessageBox::Ok,0);
	     eplorerbtn->setFocus();
	     return;
	 }
	 if(!gconf->setTempDir(tmppath->text()))
	 {
	     QMessageBox::warning(this,trUtf8("Répertoire temporaire invalide"),trUtf8("Impossible de lire ou de créer le répertoire temporaire. Veuillez en choisir un autre."),QMessageBox::Ok,0);
	     tmpbtn->setFocus();
	     return;
	 }

	 gconf->setWebActivated(webactive->isChecked());
	 pass=webpass->text();  //faut crypter le pass
	 gconf->setWebPassword(pass);
	 gconf->setWebListenPort(webport->value());
	 gconf->setMyPubKey(pubkey->text());
	 gconf->setMyPrivKey(privkey->text());

	 gconf->setIsChatTimeStamp(chatTimeStamp->isChecked());
	 gconf->setIsChanTimeStamp(chanTimeStamp->isChecked());
	 gconf->setIsCustomTimeStamp(customTimeStamp->isChecked());
	 gconf->setTimeStampString(timeStampString->text());

	 while (it)
	 {
	     gconf->addPubKey(it->text(0),it->text(1),FALSE);
	     it=it->nextSibling();
	 }
	 gconf->setAutoAcceptKey(autokey->isChecked());

	 if (modif)
	     QMessageBox::warning(this,trUtf8("Application des paramètres"),trUtf8("Certains paramètres nécessitent un redémarrage de l'application pour être pris en compte"),QMessageBox::Ok,0);
	 modif = FALSE;
	 applyBtn->setEnabled(FALSE);
     }
     else
	 QMessageBox::warning(this,trUtf8("Attention!"),trUtf8("Paire de clé invalides"),QMessageBox::Ok,0);
}


void config::openfileexpolr()
{
    QFileDialog *w=new QFileDialog(this);
    w->setMode(QFileDialog::DirectoryOnly);
    w->setCaption(trUtf8("Répertoire de destination"));
    w->show();
    if ( w->exec() == QDialog::Accepted )
         dlpath->setText(w->selectedFile());
}

void config::opentmppath()
{
    QFileDialog *w=new QFileDialog(this);
    w->setMode(QFileDialog::DirectoryOnly);
    w->setCaption(trUtf8("Répertoire temporaire"));
    w->show();
    if ( w->exec() == QDialog::Accepted )
         tmppath->setText(w->selectedFile());
}

void config::openshre()
{
    emit oshare();
}

void config::generate()
{
    QString  pub;
    QString priv;
    modif=true;
    generate_key_pair(pub,priv);
    pubkey->setText(pub);
    privkey->setText(priv);
     id->setText(generate_nodeid(pubkey->text(),privkey->text()));
}

void config::genid()
{
    id->setText(generate_nodeid(pubkey->text(),privkey->text()));
}

void config::modified()
{
    modif=true;
    setIsModified();
}

void config::setIsModified()
{
  applyBtn->setEnabled(TRUE);
}

void config::addkey()
{
    (void) new QListViewItem(keylst,node->text(),key->text());
    node->clear();
    key->clear();
}

void config::clearkey()
{
    keylst->clear();
}

void config::suppKeysSelected()
{
  QListViewItem * elt = keylst->firstChild();
  QListViewItem * temp;

  while(elt)
  {
      if(elt->isSelected())
      {
	temp = elt->nextSibling();
	delete elt;
	elt = temp;
	continue;
      }
      elt = elt->nextSibling();
  }
}

void config::openpop(QListViewItem *it,const QPoint &p,int)
{
    if (it)
    {
	QPopupMenu *menu = new QPopupMenu(keylst,trUtf8("menu"));
	menu->insertItem(trUtf8("Supprimer "),this,SLOT(suppKeysSelected()),0);
	menu->setItemVisible(0,TRUE);
	menu->exec(p);
    }
}

void config::init()
{
    initConfCategories();
    initConTypeComboBox();
    loadConfig();
    modif=false;
    
    /* connection pour le booleen "modif" affichant un warning a la validation */
    /* (sera remplacer petit a petit par le booleen "isModified" qui n'affichera plus de warning, les parametres etant pris en compte a la volee) */
    connect(nickedt,SIGNAL(textChanged(const QString&)),this,SLOT(modified()));
    connect(netkey,SIGNAL(textChanged(const QString&)),this,SLOT(modified()));
    connect(nbrslots,SIGNAL(valueChanged(const QString&)),this,SLOT(modified()));
    connect(cnxtype,SIGNAL(textChanged(const QString&)),this,SLOT(modified()));
    connect(cnxspeed,SIGNAL(valueChanged(const QString&)),this,SLOT(modified()));
    connect(listenport,SIGNAL(valueChanged(const QString&)),this,SLOT(modified()));
    connect(pubip,SIGNAL(textChanged(const QString&)),this,SLOT(modified()));
    connect(dlpath,SIGNAL(textChanged(const QString&)),this,SLOT(modified()));
    connect(tmppath,SIGNAL(textChanged(const QString&)),this,SLOT(modified()));
    connect(pubkey,SIGNAL(textChanged () ),this,SLOT(genid()));
    connect(privkey,SIGNAL(textChanged () ),this,SLOT(genid()));
    
    connect(lang,SIGNAL(activated(int)),this,SLOT(setIsModified()));
    connect(spla,SIGNAL(toggled(bool)),this,SLOT(setIsModified()));
    connect(textundericonCheckBox,SIGNAL(toggled(bool)),this,SLOT(setIsModified()));
    connect(keep,SIGNAL(valueChanged(const QString&)),this,SLOT(setIsModified()));
    connect(autocon,SIGNAL(toggled(bool)),this,SLOT(setIsModified()));
    connect(refreshAuto,SIGNAL(toggled(bool)),this,SLOT(setIsModified()));
    connect(refreshTime,SIGNAL(valueChanged(const QString&)),this,SLOT(setIsModified()));
    connect(refreshUnit,SIGNAL(textChanged(const QString&)),this,SLOT(setIsModified()));
    connect(autokey,SIGNAL(toggled(bool)),this,SLOT(setIsModified()));
    connect(webactive,SIGNAL(toggled(bool)),this,SLOT(setIsModified()));
    connect(webpass,SIGNAL(textChanged(const QString&)),this,SLOT(setIsModified()));
    connect(webport,SIGNAL(valueChanged(const QString&)),this,SLOT(setIsModified()));
    connect(chatTimeStamp,SIGNAL(toggled(bool)),this,SLOT(setIsModified()));
    connect(chanTimeStamp,SIGNAL(toggled(bool)),this,SLOT(setIsModified()));
    connect(customTimeStamp,SIGNAL(toggled(bool)),this,SLOT(setIsModified()));
    connect(timeStampString,SIGNAL(textChanged(const QString&)),this,SLOT(setIsModified()));

    //Connexion a d'autres objets - application de certains parametres a la volee
    connect(gconf,SIGNAL(updateConfRefreshShareList()),shareList,SLOT(updateConfRefreshShareList()));

    setIcon(QPixmap::fromMimeSource("config.png"));
    keylst->setAllColumnsShowFocus( TRUE );
}


void config::loadConfig()
{
    QStringList pubkeys,nodeids;

    nickedt->setText(gconf->nickname());
    netkey->setText(gconf->netKey());
    loadLanguages();
    lang->setCurrentText(gconf->language());
    spla->setChecked(gconf->splashScreen());
    textundericonCheckBox->setChecked(gconf->textUnderIcons());

    autocon->setChecked(gconf->autoCon());
    nbrslots->setValue(gconf->slotCount());
    cnxtype->setCurrentItem(cnxtype->count()-gconf->conType());
    cnxspeed->setValue(gconf->conSpeed());
    listenport->setValue(gconf->listenPort());
    pubip->setText(gconf->publicIp());
    keep->setValue(gconf->keepCon());

    dlpath->setText(QDir::convertSeparators(gconf->downloadDir()));
    tmppath->setText(QDir::convertSeparators(gconf->tempDir()));
    refreshAuto->setChecked(gconf->autoRefreshShares());
    refreshTime->setDisabled(!gconf->autoRefreshShares());
    refreshTime->setValue(gconf->autoRefreshDelay());
    refreshUnit->setDisabled(!gconf->autoRefreshShares());
    refreshUnit->setCurrentItem(gconf->autoRefreshUnit());
    textLabel5->setDisabled(!gconf->autoRefreshShares());

    chatTimeStamp->setChecked(gconf->isChatTimeStamp());
    chanTimeStamp->setChecked(gconf->isChanTimeStamp());
    customTimeStamp->setChecked(gconf->isCustomTimeStamp());
    timeStampString->setText(gconf->timeStampString());
    timeStampString->setEnabled(gconf->isCustomTimeStamp());

    webactive->setChecked(gconf->webActivated());
    //pass a decrypter quand il sera crypt�:)
    webpass->setText(gconf->webPassword());
    webport->setValue(gconf->webListenPort());
    privkey->append(gconf->myPrivKey());
    pubkey->append(gconf->myPubKey());
    id->setText(generate_nodeid(gconf->myPrivKey(),gconf->myPubKey()));
    autokey->setChecked(gconf->autoAcceptKey());

    pubkeys = gconf->pubKeys();
    nodeids = gconf->nodeIds();
    QStringList::Iterator it2 = pubkeys.begin();
    for (QStringList::Iterator it = nodeids.begin(); it != nodeids.end(); ++it,++it2 )
	if(!((*it).isEmpty()) && !((*it2).isEmpty()))
	    (void) new QListViewItem (keylst, *it, *it2);
}


void config::initConTypeComboBox()
{
    cnxtype->insertItem( QPixmap::fromMimeSource( "con5.png" ), trUtf8( "Modem" ), 0 );
    cnxtype->insertItem( QPixmap::fromMimeSource( "con3.png" ), trUtf8( "ADSL/cable xxx/128kbps" ), 1 );
    cnxtype->insertItem( QPixmap::fromMimeSource( "con3.png" ), trUtf8( "ADSL/cable xxx/256kbps" ), 2 );
    cnxtype->insertItem( QPixmap::fromMimeSource( "con4.png" ), trUtf8( "ADSL/cable xxx/512kbps" ), 3 );
    cnxtype->insertItem( QPixmap::fromMimeSource( "con4.png" ), trUtf8( "ADSL/cable xxx/768kbps" ), 4 );
    cnxtype->insertItem( QPixmap::fromMimeSource( "con2.png" ), trUtf8( "ADSL/cable xxx/1024kbps" ), 5 );
    cnxtype->insertItem( QPixmap::fromMimeSource( "con1.png" ), trUtf8( "LAN/10mbps" ), 6 );
    cnxtype->insertItem( QPixmap::fromMimeSource( "con1.png" ), trUtf8( "LAN/100mbps" ), 7 );
}


void config::setRefreshStatus()
{
    textLabel5->setEnabled(refreshAuto->isChecked());
    refreshTime->setEnabled(refreshAuto->isChecked());
    refreshUnit->setEnabled(refreshAuto->isChecked());
    refreshUnit->setCurrentItem(0);
}


void config::setRefreshMinDelay( int i )
{
    if(!i)
    {
		refreshTime->setMinValue(20);
    }
    else
    {
		refreshTime->setMinValue(1);
		refreshTime->setValue(1);
    }
}




void config::loadLanguages()
{
    QStringList l;
    QTranslator translator(this);

    QDir dir(gconf->applicationDirPath());

    dir.setFilter( QDir::Files | QDir::NoSymLinks );
    dir.setSorting( QDir::Name );
    l = dir.entryList();
    for ( QStringList::Iterator it = l.begin(); it != l.end(); ++it )
    {
	if((*it).contains("gloster_",FALSE) && (*it).contains(".qm",FALSE))
	{
	    translator.load(*it);
	    lang->insertItem(translator.findMessage("MainWin","LOCALNAME").translation(),-1);
	}
    }
}


void config::initConfCategories()
{
    listBox->insertItem(QPixmap::fromMimeSource("Gloster16.png"),trUtf8("Général"),0);
    listBox->insertItem(QPixmap::fromMimeSource("chat16.png"),trUtf8("Chat/chan"),1);
    listBox->insertItem(QPixmap::fromMimeSource("network_app.png"),trUtf8("Connexion"),2);
    listBox->insertItem(QPixmap::fromMimeSource("folder16.png"),trUtf8("Dossiers"),3);
    listBox->insertItem(QPixmap::fromMimeSource("object.png"),trUtf8("Cryptage"),4);
    listBox->insertItem(QPixmap::fromMimeSource("key16.png"),trUtf8("Clés"),5);
    listBox->insertItem(QPixmap::fromMimeSource("web_server.png"),trUtf8("Serveur web"),6);
}


void config::setPage( int i )
{
    switch(i)
    {
    case 0:
	widgetStack3->raiseWidget(0);
	break;
    case 1:
	widgetStack3->raiseWidget(6);
	break;
    default:
	widgetStack3->raiseWidget(i-1);
    }
}


void config::validate()
{
    writeSettings();
    close();
}
