/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include "../network/gnetwork.h"
#include "chancreate.h"
#include "cntlst.h"
#include "mainwin.h"
#include <qsettings.h>
#include <qstringlist.h>
#include <qlistview.h>
#include <qtimer.h>
#include <qlabel.h>
#include <qstatusbar.h>
#include <qregexp.h>
#include <qvalidator.h>
#include <qmessagebox.h>
#include <qfont.h>

//Delai de 10 secondes pour le timer de reconnexion auto
#define TIMER_DELAY 10*1000

extern GNetwork *net;



void Connex::con()
{
   if (net)
   {
       keepMinConnections = TRUE;
       if (!(isconnected(ip->text(),port->text())))
       {
	   changeList(ip->text(),port->text(),liste,stlst);
	   net->connecttohost(ip->text(),port->text().toUShort());
       }
       emit updatelst();
   }
}

bool Connex::isconnected(const QString& ip, const QString& port)
{
    QListViewItem* lst=stlst->firstChild();
    while (lst)
    {
	if (lst->text(0)==ip && lst->text(1)==port)
	    break;
	else
	    lst=lst->nextSibling();

    }
    return lst;
}

void Connex::writelst()
{
    QListViewItem* lst=liste->firstChild();
    QStringList listeip;
    QStringList listeport;
    int i;

    for (i=0;i<liste->childCount();++i)
    {
	listeip << lst->text(0);
	listeport << lst->text(1);
	lst=lst->itemBelow();
    }
    lst = stlst->firstChild();
     for (i=0;i<stlst->childCount();++i)
    {
	listeip << lst->text(0);
	listeport << lst->text(1);
	lst=lst->itemBelow();
    }
  gconf->setIpList(listeip);
  gconf->setPortList(listeport);
}

void Connex::getip(QListViewItem* elt)
{
    if (elt)
    {
	ip->setText(elt->text(0));
	port->setText(elt->text(1));
    }
}

void Connex::showmenu(QListViewItem *it,const QPoint &p,int)
{
    if (it)
    {
	QPopupMenu *menu = new QPopupMenu(liste,tr("menu"));
	menu->insertItem(tr("Supprimer"),this,SLOT(removeip()),0,0);
	menu->insertSeparator();
	menu->insertItem(tr("Supprimer tout"),this,SLOT(clearList()),0,1);
	menu->setItemVisible(0,TRUE);
	menu->setItemVisible(1,TRUE);
	menu->exec(p);
    }
    else
    {
	QPopupMenu *menu = new QPopupMenu(liste,tr("menu"));
	menu->insertItem(tr("Supprimer tout"),liste,SLOT(clear()),0,0);
	menu->setItemVisible(0,TRUE);
	menu->exec(p);
    }
}

void Connex::removeip()
{
    QListViewItem * elt = liste->firstChild();
    QListViewItem * temp;
    while(elt)
    {
	temp = elt->nextSibling();
	if(elt->isSelected())
	    delete(elt);
	elt = temp;
    }
    writelst();
    currentTimerElt = liste->firstChild();
}


void Connex::onconnect(const QString &IPAddr, Q_UINT16 Port)
{
    QListViewItem* lst=stlst->firstChild();

    while ((lst) && ((lst->text(0)==IPAddr) && (lst->text(1)==Port)))
	lst=lst->nextSibling();

    if (lst)
	lst->setText(2,tr("Connect"));
    else
	(void) new QListViewItem (stlst,IPAddr,QString::number(Port),tr("Connect"));

    updateKeepConLabel();
}


void Connex::ondisconnect(const QString &IPAddr, Q_UINT16 Port)
{
    changeList(IPAddr,QString::number(Port),stlst,liste);
    if(minKeepCon->text().toInt()>stlst->childCount() && keepMinConnections)
	timer->start(TIMER_DELAY,TRUE);
}


void Connex::conto(const QString& ip, const QString& port)
{
    if (net)
	if (!(isconnected(ip,port)))
	{
	net->connecttohost(ip,port.toUShort());
    }
}

void Connex::timeout()
{
    QListViewItem * next;

    if(minKeepCon->text().toInt()==stlst->childCount() || keepMinConnections == FALSE)
	return;

    if(!currentTimerElt)
	currentTimerElt = liste->firstChild();

    while ((currentTimerElt) && (minKeepCon->text().toInt()>stlst->childCount()))
    {
	if (!(isconnected(currentTimerElt->text(0),currentTimerElt->text(1))))
	{
	    next = currentTimerElt->nextSibling();
	    changeList(currentTimerElt,stlst);
        	    net->connecttohost(currentTimerElt->text(0),currentTimerElt->text(1).toUShort());
	    currentTimerElt = next;
	}
	else
	    currentTimerElt = currentTimerElt->nextSibling();

	if(!currentTimerElt)
	    currentTimerElt = liste->firstChild();
    }
}

void Connex::newcnt(Q_UINT16 port, const QString & ip)
{
    if(!hostInfosExists(liste,ip,port) && !hostInfosExists(stlst,ip,port))
	(void) new QListViewItem (liste,ip,QString::number(port));

    emit updatelst();
}

void Connex::changeList(const QString& ip, const QString& port,QListView * l1, QListView * l2)
{
    QListViewItem * elt = l1->firstChild();

    while (elt && ((elt->text(0)!=ip) || (elt->text(1)!=port)))
	elt = elt->nextSibling();

    if(elt)
    {
	if(elt == currentTimerElt)
	    currentTimerElt = elt->nextSibling();

	l2->insertItem(elt);
	elt->setText(2,tr("Connexion..."));
    }
    else
	(void) new QListViewItem(l2,ip,port,tr("Connexion..."));
}

void Connex::changeList(QListViewItem * elt, QListView * l1)
{
  l1->insertItem(elt);
  elt->setText(2,tr("Connexion..."));
}


void Connex::init()
{
    timer = new QTimer(this);
    setIcon(QPixmap::fromMimeSource("network.png"));
    cancel->setPixmap(QPixmap::fromMimeSource("cancel16.png"));
    keepMinConnections = TRUE;
    minKeepCon->setText(QString::number(gconf->keepCon()));

    text=new QLabel(statusBar());
    text->setFont(QFont("AnyStyle",8,QFont::Normal,TRUE));
    statusBar()->addWidget(text,1,true);

    liste->setAllColumnsShowFocus(TRUE);
    stlst->setAllColumnsShowFocus(TRUE);

    connect(timer,SIGNAL(timeout()),this,SLOT(timeout()));
    connect(this,SIGNAL(updatelst()),this,SLOT(writelst()));
    connect(this,SIGNAL(updatelbl()),this,SLOT(updateKeepConLabel()));
    connect(net,SIGNAL(connected(const QString&, Q_UINT16)),this,SLOT(onconnect(const QString &, Q_UINT16)));
    connect(net,SIGNAL(disconnected(const QString &, Q_UINT16)),this,SLOT(ondisconnect(const QString &, Q_UINT16)));
    connect(net,SIGNAL(newcnt(Q_UINT16, const QString &)),this,SLOT(newcnt(Q_UINT16, const QString &)));

    updateKeepConLabel();
    loadHostsList();
    if(gconf->autoCon())
		autoConnexion();
}


void Connex::stopConnections()
{
    keepMinConnections = FALSE;
}


void Connex::loadHostsList()
{
    QStringList portlist = gconf->portList();
    QStringList iplist = gconf->ipList();
    QStringList::Iterator it2 = portlist.begin();
    for (QStringList::Iterator it = iplist.begin(); it != iplist.end(); ++it,++it2 )
	(void) new QListViewItem (liste, *it, *it2);

    currentTimerElt = liste->firstChild();
}


void Connex::updateKeepConLabel()
{
    int n = minKeepCon->text().toInt()-stlst->childCount();
    if(n <=0)
	text->setText(tr("Minimum de connexions requis atteint"));
    else if(n==1)
	text->setText(tr("Minimum de connexions requis non atteint")+" ("+"1 "+tr("connexion restante")+")");
    else
	text->setText(tr("Minimum de connexions requis non atteint")+" ("+QString::number(n)+" "+tr("connexions restantes")+")");
}


void Connex::validateLabels()
{
    QString error;
    bool pb=FALSE;

    if((ip->text() == ""))
    {
	error = tr("L'adresse n'est pas valide!");
	pb = TRUE;
    }

    if(port->text().toInt()==0 || port->text().toInt()>65535 || port->text().toInt()<1)
    {
	if(error == QString::null)
	    error = tr("Le port doit tre compris entre 1 et 65535.");
	else
	    error += "\n"+tr("Le port doit tre compris entre 1 et 65535.");
	port->setText("");
	pb = TRUE;
    }

    if(pb)
	QMessageBox::warning(this,tr("Paramtres invalides!"),error,QMessageBox::Ok,QMessageBox::NoButton,QMessageBox::NoButton);
    else
	con();
}

void Connex::keepcon_textChanged( const QString & t)
{
    gconf->setKeepCon(t.toInt());
    emit updatelbl();
}

void Connex::autoConnexion()
{
    int i=0;
    int j=gconf->keepCon();
    QListViewItem * item = liste->firstChild();

    while(item && i<j)
    {
	net->connecttohost(item->text(0),item->text(1).toUShort());
	changeList(item,stlst);
	i++;
	item = item->nextSibling();
    }
}




void Connex::closeEvent( QCloseEvent * e )
{
    hide();
    e->ignore();
}


QListViewItem * Connex::hostInfosExists( QListView * lv, const QString & ip, Q_UINT16 port )
{
    QListViewItem* lst=lv->firstChild();

    while (lst)
    {
	if((lst->text(0)==ip) && (lst->text(1)==QString::number(port)))
	    break;
	lst=lst->nextSibling();
    }
    return lst;
}


void Connex::clearList()
{
    liste->clear();
    writelst();
}

bool Connex::event( QEvent * e )
{
    bool b;
    QEvent::Type t = e->type();
    b = QWidget::event(e);
    if( t == QEvent::LanguageChange)
	updateKeepConLabel();
    return b;
}

void Connex::updateConfAutoCon()
{
	if(gconf->autoCon())
		autoConnexion();
	else
		stopConnections();
}

void Connex::updateConfKeepCon()
{
	minKeepCon->setText(QString::number(gconf->keepCon()));
}
