#ifndef QSHAREFILEVIEW_H
#define QSHAREFILEVIEW_H
#include <qgrid.h>
#include <qlistview.h>
#include <qstring.h>
#include <qwidget.h>
#include <qobject.h>
#include <qfile.h>
#include <qpoint.h>
#include <qdragobject.h>
#include <qevent.h>
#include <qxml.h>
#include <qpushbutton.h>
#include <qpopupmenu.h>
#include <qdragobject.h>
#include <qmainwindow.h>

#include <qlayout.h>

#include "vdirview.h"
#include "dirview.h"
#include "structureparser.h"
#include "../gconfig.h"

extern GConfig * gconf;

class vFileBrowser:public QWidget
{
		Q_OBJECT
	
	public :
		vFileBrowser(QWidget * parent = 0, QString xmlpath = gconf->applicationDirPath()+"filelist.xml", bool activeDrop = TRUE, const char * name = 0, WFlags f = 0);
		vDirectoryView * arbre() {return nameSpace;};
		QString getNodeid() {return nameSpace->nodeid;}
		
	public slots :
		void updateFileview(QListViewItem * newselect);
		void hideVfv ();
		void disableVSpace();
		void enableVSpace();
		inline QListView * leftListView() { return nameSpace; }
		inline Q_UINT32 nbFiles() { return nameSpace->nbFiles(); }
		inline double totalSize() { return nameSpace->totalSize(); }
	
	signals :
		void sendLoadLabel(const QString &);
		void sendDefaultLabel(const QString &);
		void enableEnv(bool);
	
	private :
	/* functions */
		bool loadXmlFile(QString & path);
		void initNameSpace();
		vListItem * getCurrentDir();
		vListItem * getParent();
		vListItem * getElement(QString& name);
		vListItem * findSelectedItemChild(QString name);
	
	/* variables */
		vDirectoryView * nameSpace;
		vDirView * vfileViewer;
		QBoxLayout * vBrowserGrid;
		QPushButton * hideVbutton;
		QFile xmlFile;
		bool activedrop;
		StructureParser * handler;
	
		friend class vDirectoryView;
};


class userFileBrowser : public QMainWindow
{
	Q_OBJECT
	
	public:
    userFileBrowser( const QString& fpath, QWidget *parent = 0, const char *name = 0, WFlags f = 0)
			: QMainWindow(parent,name,f)
	{
		setIcon(QPixmap(":/fileshare.png"));
		setCentralWidget(new vFileBrowser(this,fpath,false,0,0));
		setCaption(tr("Fichiers de")+ " : "+graphe->nodes(graphe->NodeidToId(((vFileBrowser *)centralWidget())->getNodeid())).name);
	}
};


#endif
