#include <qstring.h>
#include <qlistview.h>
#include "structureparser.h"
#include "../../files/xmlparser.h"
#include "vdirview.h"
#include "dirview.h"

StructureParser::StructureParser(  vDirectoryView * t, bool fillnodeid )
                : QXmlDefaultHandler()
{
		fillNodeid = fillnodeid;
    setListView( t );
}

void StructureParser::setListView(  vDirectoryView * t )
{
    table = t;
}


bool StructureParser::startElement( const QString& ,
                                    const QString& ,
                                    const QString& qname,
                                    const QXmlAttributes& attributes)
{
  QListViewItem * element;
	if(qname != "hashes" && qname !="infos")
	{
		if ( ! stack.isEmpty() )
		{
			vListItem *lastChild = (vListItem *) stack.top()->firstChild();
			if ( lastChild )
			{
				while ( lastChild->nextSibling() )
					lastChild = (vListItem *) lastChild->nextSibling();
			}
			if(qname == "file")
			{
				QFileInfo f(attributes.value("path"));
				if(f.isReadable() || !table->activedrop)
				{
					QStringList hashlist;
					hashlist << attributes.value("hash");
					if(attributes.count()>ATTRIB_WO_PCHUNK)
						for(int i=0;i<attributes.count()-ATTRIB_WO_PCHUNK;++i)
							hashlist << attributes.value("p"+QString::number(i));
					element = new vListItem( stack.top(), attributes.value("name"), attributes.value("size"),fileNormal,
											item_file,attributes.value("path"),hashlist,attributes.value("lastmodified").toUInt(),attributes.value("type").toUInt());
					element->setVisible(FALSE);
					table->incNbFiles(f.size());
				}
				return true;
			}
			else
				element = new vListItem( (vListItem *) stack.top(),attributes.value("name"),QString::null,folderClosed,item_dir);
		}
		else
			element = new vListItem( table, attributes.value("name"),QString::null,folderOpen,item_special);
		stack.push( element );
		element->setRenameEnabled (0,TRUE);
	}
	else if(qname == "infos" && fillNodeid)
		table->nodeid = attributes.value("nodeid");

    return TRUE;
}

bool StructureParser::endElement( const QString&, const QString&,
                                  const QString& qname)
{
	if (qname != "file") stack.pop();
    return TRUE;
}


bool StructureParser::endDocument()
{
	table->firstChild()->setRenameEnabled(0,false);
	table->firstChild()->setOpen(true);
	return TRUE;
}
