/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qapplication.h>
#include <qdockwindow.h>
#include<qcombobox.h>
#include<qspinbox.h>
#include <qpixmap.h>
#include <qfiledialog.h>
#include <qmessagebox.h>
#include <qtextcodec.h>
#include <qpopupmenu.h>
#include "../main.h"
#include "mainwin.h"
#include "cntlst.h"
#include "../crypt/crypt_rsa.h"
#include "../network/gnetwork.h"
#include "trayicon.h"
#include "../files/gdownloader.h"
#include "../glanguage.h"
#include "../gconfig.h"
#include "../network/gipaddr.h"

extern GNetwork *net;
extern GConfig * gconf;

void firstconf::writeSettings()
{
    gconf->setWSize(800);
    gconf->setHSize(600);
    gconf->setIsMaximized(TRUE);
    
    gconf->setNickname(nick->text());
    gconf->setNetKey(netkey->text());
    gconf->setSplashScreen(TRUE);
    gconf->setConType(cnxtype->count()-cnxtype->currentItem());
    gconf->setAutoCon(FALSE);
    gconf->setKeepCon(FALSE);
    gconf->setConSpeed(cnxspeed->text().toInt());
    gconf->setListenPort(listenport->value());
    gconf->setSlotCount(slot->value());
    gconf->setPublicIp(pubip->currentText());
    if(!gconf->setDownloadDir(dlpath->text()))
    {
	QMessageBox::warning(this,tr("Rpertoire de destination invalide"),tr("Impossible de lire ou de crer le rpertoire de destination. Veuillez en choisir un autre."),QMessageBox::Ok,0);
	dlbtn->setFocus();
	return;
    }
    if(!gconf->setTempDir(tmppath->text()))
    {
	QMessageBox::warning(this,tr("Rpertoire temporaire invalide"),tr("Impossible de lire ou de crer le rpertoire temporaire. Veuillez en choisir un autre."),QMessageBox::Ok,0);
	tmpbtn->setFocus();
	return;  
    }
    if(genKeys->isChecked())
	generate();
    gconf->setAutoAcceptKey(TRUE);
    
    gconf->setLanguage(GLanguage::findLanguage());
    
    gconf->setWebActivated(FALSE);
    gconf->setWebListenPort(8080);
    gconf->setWebPassword("");
    
    gconf->setChatTextColor(Qt::black);
    gconf->setIsChatTextBold(FALSE);
    gconf->setIsChatTextItalic(FALSE);
    gconf->setIsChatTextUnderlined(FALSE);
    
    gconf->writeTypes();
    gconf->setIsConfigured(TRUE);
    disconnect(this,SIGNAL(destroyed()));
    launchMainWin();
    close();
}

void firstconf::openfileexpolr()
{
    QFileDialog *w=new QFileDialog(this);
    w->setMode(QFileDialog::DirectoryOnly);
    w->show();
    if ( w->exec() == QDialog::Accepted )
         dlpath->setText(w->selectedFile());
}

void firstconf::opentmppath()
{

    QFileDialog *w=new QFileDialog(this);
    w->setMode(QFileDialog::DirectoryOnly);
    w->show();
    if ( w->exec() == QDialog::Accepted )
         tmppath->setText(w->selectedFile());
}

void firstconf::generate()
{
    QString  pub;
    QString priv;
    generate_key_pair(pub,priv);
    gconf->setMyPrivKey(priv);
    gconf->setMyPubKey(pub);
}

void firstconf::addip(const QString &ip)
{
     int i;
for(i=0;i<pubip->count()-1;++i)
    {
    if (ip==pubip->text(i))
	break;
    }

if (i>=pubip->count()-1)
  pubip->insertItem(ip);

pubip->setCurrentItem(pubip->count()-1);
}


void firstconf::init()
{
    initComboBox();
    GIpAddr * ipaddr = new GIpAddr(this,"ipaddr");
    QObject::connect(ipaddr,SIGNAL(internetIP(const QString&)),this,SLOT(addip(const QString&)));
    QObject::connect(ipaddr,SIGNAL(lanIP(const QString&)),this,SLOT(addip(const QString&)));
    dlpath->setText(QDir::convertSeparators(gconf->applicationDirPath())+"Incoming");
    tmppath->setText(QDir::convertSeparators(gconf->applicationDirPath())+"Temp");
    backbtn->setEnabled(FALSE);
    if(!check_key_pair(gconf->myPubKey(),gconf->myPrivKey()))
    {
	genKeys->setDisabled(TRUE);
	genKeys->setChecked(TRUE);
    }
}


void firstconf::nextPage()
{
    switch(wizard->id(wizard->visibleWidget()))
    {
    case 0:
    case 3:
	break;
    case 1:
	if(nick->text().isEmpty())
	{
	    warningMsg(tr("Vous devez spcifier un pseudo"));
	    return;
	}
	else 
	    if(netkey->text().isEmpty())
	    {
		warningMsg(tr("Vous devez spcifier un nom de rseau"));
		return;
	    }
	break;	
    case 2:
	if(pubip->currentText().isEmpty())
	{
	    warningMsg(tr("Vous devez spcifier une adresse IP ou un nom de domaine"));
	    return;
	}
	else
	    if(listenport->value() == 0)
	    {
		warningMsg(tr("Le port choisi n'est pas valide"));
		return;
	    }
	break;
    case 4:
	if(dlpath->text().isEmpty())
	{
	    warningMsg(tr("Vous devez choisir un rpertoire de destination"));
	    return;
	}
	else
	    if(tmppath->text().isEmpty())
	    {
		warningMsg(tr("Vous devez choisir un rpertoire temporaire"));
		return;
	    }
	break;
    }
  
    int i = wizard->id( wizard->visibleWidget()) + 1;
    wizard->raiseWidget(i);
    if(i==4)
	btnStack->raiseWidget(1);
    else
	btnStack->raiseWidget(0);
    backbtn->setEnabled(TRUE);
}


void firstconf::backPage()
{
    int i = wizard->id(wizard->visibleWidget()) - 1;
    wizard->raiseWidget(i);
    if(i==0)
	backbtn->setEnabled(FALSE);
    else
	backbtn->setEnabled(TRUE);
    btnStack->raiseWidget(0);
}

void firstconf::initComboBox()
{
    cnxtype->insertItem( QPixmap::fromMimeSource( "con5.png" ), tr( "Modem" ), 0 );
    cnxtype->insertItem( QPixmap::fromMimeSource( "con3.png" ), tr( "ADSL/cable xxx/128kbps" ), 1 );
    cnxtype->insertItem( QPixmap::fromMimeSource( "con3.png" ), tr( "ADSL/cable xxx/256kbps" ), 2 );
    cnxtype->insertItem( QPixmap::fromMimeSource( "con4.png" ), tr( "ADSL/cable xxx/512kbps" ), 3 );
    cnxtype->insertItem( QPixmap::fromMimeSource( "con4.png" ), tr( "ADSL/cable xxx/768kbps" ), 4 );
    cnxtype->insertItem( QPixmap::fromMimeSource( "con2.png" ), tr( "ADSL/cable xxx/1024kbps" ), 5 );
    cnxtype->insertItem( QPixmap::fromMimeSource( "con1.png" ), tr( "LAN/10mbps" ), 6 );
    cnxtype->insertItem( QPixmap::fromMimeSource( "con1.png" ), tr( "LAN/100mbps" ), 7 );
}


void firstconf::warningMsg( const QString & msg )
{
    QMessageBox::warning(this,tr("Tous les champs doivent tre remplis"),msg,QMessageBox::Ok,0);
}
