/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qapplication.h>
#include <qwidgetlist.h>
#include <qdockwindow.h>
#include <qlineedit.h>
#include <qspinbox.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qstringlist.h>
#include <qvaluelist.h>
#include <qlistbox.h>
#include <qlistview.h>
#include <qpixmap.h>
#include <qtabwidget.h>
#include <qmessagebox.h>
#include <qtextedit.h>
#include <qevent.h>
#include <qstatusbar.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qgl.h>

#include "../version.h"
#include "mainwin.h"
#include "config.h"
#include "statut.h"
#include "transferts.h"
#include "chancreate.h"
#include "recherche.h"
#include "chanwin.h"
#include "../network/gnetwork.h"
#include "../gtypes.h"
#include "connex.h"
#include "cntlst.h"
#include "pvmsg.h"
#include "filelist/sharefilebrowser.h"
#include "../files/gdownloader.h"
#include "filelist/qsharefileview.h"
#include "../crypt/crypt_rsa.h"
#include "trayicon.h"
#include "../webserver/gwebserver.h"

extern GNetwork *net;
extern GWebServer *httpd;
extern TrayIcon *tray;


QWidget * MainWin::isOpen(const QString& name)
{
    int i=0;
    QWidget * pres=0;
    QWidgetList windows = wrk->windowList(QWorkspace::CreationOrder);
    QString namelower = name.lower();
    while(i <int(windows.count()) && !pres)
    {
	if(windows.at(i)->caption().lower() == namelower)
	    pres = windows.at(i);
	i++;
    }
    return pres;
}

void MainWin::createToolBars()
{
    /* Toolbar des raccourcis */
    setUsesTextLabel(gconf->textUnderIcons());
    fichierconnectAction->addTo(Toolbar);
    fichierconnectAction->setIconSet(QPixmap::fromMimeSource("network.png"));
    fileconfigAction->addTo(Toolbar);
    fileconfigAction->setIconSet(QPixmap::fromMimeSource("config.png"));
    Action_share->addTo(Toolbar);
    Action_share->setIconSet(QPixmap::fromMimeSource("fileshare.png"));
    Toolbar->addSeparator();
    fenetresStatutAction->addTo(Toolbar);
    fenetresStatutAction->setIconSet(QPixmap::fromMimeSource("statut.png"));
    fenetresTransfertsAction->addTo(Toolbar);
    fenetresTransfertsAction->setIconSet(QPixmap::fromMimeSource("transferts.png"));
    fenetresRechercheAction->addTo(Toolbar);
    fenetresRechercheAction->setIconSet(QPixmap::fromMimeSource("search.png"));
    Toolbar->addSeparator();
    fenetresChatcreer_chanAction->addTo(Toolbar);
    fenetresChatcreer_chanAction->setIconSet(QPixmap::fromMimeSource("wizard.png"));
    fileExitAction->setIconSet(QPixmap::fromMimeSource("cancel.png"));
    fenetresChatAction->setIconSet(QPixmap::fromMimeSource("chat.png"));
    menuCascadeAction->setIconSet(QPixmap::fromMimeSource("apps.png"));
    menuMosaiqueAction->setIconSet(QPixmap::fromMimeSource("app.png"));

    Toolbar->setNewLine(TRUE);
    taskBar = new QToolBar(this, "barre des tches" );
    taskBar->setLabel(tr("Barre des tches"));
    taskBar->hide();
}


void MainWin::createdockwin()
{
    dockwin.setOpaqueMoving(true);
    dockwin.setResizeEnabled(false);
    dockwin.setHorizontallyStretchable(false);
    dockwin.setVerticallyStretchable(true);
    dockwin.setFixedExtentWidth(235);
    dockwin.setMovingEnabled(false);
    dockwin.setCloseMode(QDockWindow::Always);
    dockwin.focusPolicy();
}

void MainWin::initStatusBar()
{
    QWidget * w;
    QLabel * l;
    QHBoxLayout * b;
    QSizePolicy spPix(QSizePolicy::Maximum,QSizePolicy::Minimum);

    //Infos sur le hachage et le nombre de fichiers partages
    w = new QWidget(statusBar());
    b = new QHBoxLayout(w);
    text=new QLabel(w);
    text->setSizePolicy(QSizePolicy::MinimumExpanding,QSizePolicy::Minimum);
    l = new QLabel(w);
    l->setPixmap(QPixmap::fromMimeSource("fileshare16.png"));
    l->setSizePolicy(spPix);
    b->addWidget(l);
    b->addWidget(text);
    statusBar()->addWidget(w,1,true);

    //Infos sur la bande passante utilisee
    w = new QWidget(statusBar());
    b = new QHBoxLayout(w);
    b->setSpacing(5);
    b->setMargin(3);
    b->addSpacing(2);
    l = new QLabel(w);
    l->setPixmap(QPixmap::fromMimeSource("down.png"));
    l->setSizePolicy(spPix);
    b->addWidget(l);
    dwlbl = new QLabel(w);
    dwlbl->setSizePolicy(QSizePolicy::MinimumExpanding,QSizePolicy::Minimum);
    dwlbl->setText(tr("Rc.")+" : 0.0 Ko/s");
    b->addWidget(dwlbl);
    b->addSpacing(8);
    l = new QLabel(w);
    l->setText("|");
    l->setSizePolicy(spPix);
    b->addWidget(l);
    b->addSpacing(8);
    l = new QLabel(w);
    l->setPixmap(QPixmap::fromMimeSource("up.png"));
    l->setSizePolicy(spPix);
    b->addWidget(l);
    uplbl = new QLabel(w);
    uplbl->setSizePolicy(QSizePolicy::MinimumExpanding,QSizePolicy::Minimum);
    uplbl->setText(tr("Env.")+" : 0.0"+(!gconf->conSpeed()?"":"/"+QString::number(gconf->conSpeed())+".0")+" Ko/s");
    b->addWidget(uplbl);
    b->addSpacing(2);
    statusBar()->addWidget(w,0,true);

    nbuserslbl = new QLabel(statusBar());
    nbuserslbl->setText(" 1 "+tr("utilisateur")+" ");

    statusBar()->addWidget(nbuserslbl,0,true);
}



void MainWin::createnetwork()
{
    if (net)
	delete net;

    net=new GNetwork(gconf->nickname(),generate_nodeid(gconf->myPrivKey(),gconf->myPubKey()),gconf->publicIp(),(t_connexion) gconf->conType(),gconf->conSpeed(),FALSE,gconf->slotCount(),gconf->downloadDir(),gconf->tempDir(),gconf->netKey() ,this);

    net->listen(gconf->listenPort());
}




void MainWin::refreshSharedFiles()
{
    shareFileBrowserWindow *w=new shareFileBrowserWindow(wrk,0,WDestructiveClose);
    w->hide();
    connect(w,SIGNAL(updateStatusBar(const QString&)),this,SLOT(updatebar(const QString&)));
    connect(w,SIGNAL(statsInfos(Q_UINT32,double)),this,SLOT(updatestate(Q_UINT32,double)));
    w->validButton();
}



void MainWin::updatestate(Q_UINT32 nbr,double size)
{
    text->setText(QString::number(nbr)+" "+tr("Fichiers Partags")+" ("+QString::number(size,'f',1)+" Mo)" );
}

void MainWin::updatebar(const QString &msg)
{
   text->setText(msg);
}



void MainWin::setcurfocus(QWidget *w)
{
    int i;
    QWidgetList windows =  wrk->windowList(QWorkspace::CreationOrder);
    for (i = 0; i <int(windows.count()); i++)
    {
	if  (windows.at(i)->caption() == (w->caption()))
	{
	    wrk->windowList(QWorkspace::CreationOrder).at(i)->setFocus();
	    wrk->windowList(QWorkspace::CreationOrder).at(i)->show();
	    break;
	}
    }
}

void MainWin::openConnect()
{
    Connex * w;

    if (!(w = (Connex *)isOpen(tr("Connexion"))))
	w = new Connex (wrk,0,WDestructiveClose);

	connect(gconf,SIGNAL(updateConfAutoCon()),w,SLOT(updateConfAutoCon()));
	connect(gconf,SIGNAL(updateConfKeepCon()),w,SLOT(updateConfKeepCon()));

    w->show();
    w->setFocus();
    updateTaskBar();
}



void MainWin::openConfig()
{
    config * w;

    if (!(w = (config*) isOpen(tr("Configuration"))))
    {
	w = new config (wrk,0,WDestructiveClose);
	connect(w,SIGNAL(oshare()),this,SLOT(openSharedFilesWindow()));
	w->show();
	updateTaskBar();
    }
    else
	setcurfocus(w);
}


void MainWin::openSharedFilesWindow()
{
    shareFileBrowserWindow *w;

    if (!(w = (shareFileBrowserWindow *) isOpen(tr("Fichiers partags"))))
    {
	w =new shareFileBrowserWindow(wrk,0,WDestructiveClose);
	w->show();
	connect(w,SIGNAL(updateStatusBar(const QString&)),this,SLOT(updatebar(const QString&))		);
	connect(w,SIGNAL(statsInfos(Q_UINT32,double)),this,SLOT(updatestate(Q_UINT32,double)));
    }
    else
    {
	w->pauseXmlGen();
	w->show();
	w->setFocus();
    }
    updateTaskBar();
}

void MainWin::openStatut()
{
    Statut * w;
	if(QGLFormat::hasOpenGL())
    {
		if (!(w = (Statut *)isOpen(tr("Statut"))))
		{
			w=new Statut (wrk,0,WDestructiveClose);
			w->show();
			updateTaskBar();
		}
		else
			w->setFocus();
	}
	else
		QMessageBox::warning(this,tr("Pas de support OpenGL"),tr("Impossible d'afficher le status. Votre systme ne supporte pas OpenGL"),QMessageBox::Ok,0);
}

void MainWin::openTransferts()
{
    transferts * w;

    if (!(w = (transferts *) isOpen(tr("Transferts"))))
    {
	w = new transferts (wrk,0,WDestructiveClose);
	w->tab->showPage(w->tab->page(1));
	w->hide();
	updateTaskBar();
    }
    else
    {
	w->setFocus();
	w->show();
    }
}


void MainWin::openCreerChan()
{
    chanCreate * w;
    if (!(w = (chanCreate *)isOpen(tr("Crer un chan"))))
    {
	w=new chanCreate (wrk,0,WDestructiveClose);
	w->show();
	connect(w,SIGNAL(cree(QString)),this,SLOT(creationchan(QString)));
	connect(w,SIGNAL(erreur(QString)),this,SLOT(openerror(QString)));
	updateTaskBar();
    }
    else
	w->setFocus();
}


void MainWin::openRecherche()
{
    recherche * w;
    if (!(w = (recherche *)isOpen(tr("Recherche"))))
    {
	w = new recherche (wrk,0,WDestructiveClose);
	w->show();
	updateTaskBar();
    }
    else
	w->setFocus();
}



void MainWin::creationchan(QString title)
{
    chanwin *w;
    if(!(w = (chanwin*) isOpen(title)))
    {
	w = new chanwin(wrk,0,WDestructiveClose);
	w->setName(title);
	net->sendChatUserEvent(title,true);
	w->show();
    }
    else
	w->setFocus();
}


void  MainWin::apropos()
{

    QMessageBox::about( this,tr( "A Propos de Gloster " GLOSTER_VERSION),tr("Pour plus d'informations, visitez http://gloster.sf.net \n \n Dvelopp par CrYpToNyM, Loki, Meteoryte, Z")+"\n\n"+tr("Traduction ralis par")+" "+tr("TRADUCTOR_NAME")+" ("+tr("TRADUCTOR_MAIL")+")");


}


void MainWin::UpdateMenu()
{
    int i,id,j;
    QWidgetList windows = wrk->windowList(QWorkspace::CreationOrder);

    Fenetres->clear();

    Fenetres->insertItem(QPixmap::fromMimeSource("cancel.png"), tr("Fermer"),this,SLOT(closeActiveWindow()),CTRL+Key_F4,0);
    Fenetres->insertItem(QPixmap::fromMimeSource("cancel.png"), tr("Fermer tout"),this,SLOT(closeAllWindows()),CTRL+SHIFT+Key_F4,1);
    Fenetres->insertSeparator();
    Fenetres->insertItem(tr("Suivante"),this,SLOT(activateNextWindow ()),CTRL+Key_Tab,2);
    Fenetres->insertItem(tr("Prcdente"),this,SLOT(activatePrevWindow ()),CTRL+SHIFT+Key_Tab,3);
    Fenetres->insertSeparator();
    Fenetres->insertItem(QPixmap::fromMimeSource("app.png") ,tr("Mosaque"),wrk,SLOT(tile()));
    Fenetres->insertItem( QPixmap::fromMimeSource("apps.png") ,tr("Cascade"),wrk,SLOT(cascade()));
    Fenetres->insertSeparator();

    j = 1;
    for (i = 0; i <int(windows.count()); i++)
    {
	if(!windows.at(i)->isHidden())
	{
	    id = Fenetres->insertItem(QString::number(j)+". "+windows.at(i)->caption(), this, SLOT(winfocus(int)));
	    Fenetres->setItemParameter( id, i );
	    Fenetres->setItemChecked( id, wrk->activeWindow() == windows.at(i) );
	    ++j;
	}
    }
    if(j==1)
    {
	Fenetres->setItemEnabled(0,FALSE);
	Fenetres->setItemEnabled(1,FALSE);
	Fenetres->setItemEnabled(2,FALSE);
	Fenetres->setItemEnabled(3,FALSE);
    }
}


void MainWin::winfocus( int id )
{
    QWidget* w = wrk->windowList(QWorkspace::CreationOrder).at( id );
    w->setFocus();
    if ((w->caption()==tr("Connexion")) || (w->caption()==tr("Transferts")))
	w->show();
    Fenetres->setItemChecked( id, true );
}

void MainWin::openerror(QString er)
{

    QMessageBox* w= new QMessageBox(this,"w");
    w->setText(er);
    w->setIcon(QMessageBox::Warning);
    w->show();

}



void MainWin::openlstcnt()
{
    contactlst *w=new contactlst ((QWidget*)&dockwin,0,WDestructiveClose);
    dockwin.boxLayout()->addWidget(w);
    dockwin.setHorizontallyStretchable(false);
    w->show();
    moveDockWindow(&dockwin,DockRight);
    connect(w,SIGNAL(sndpvmsg(QString,Q_UINT16)),this,SLOT(openpvmsg(QString,Q_UINT16)));
    connect(net,SIGNAL(recvChatPv(Q_UINT16,const QString&, const QString&)),this,SLOT(rcvmsg(Q_UINT16,const QString&,const QString&)));
    connect(w,SIGNAL(hidedock(bool)),this,SLOT(hidedockwin(bool)));
    connect(w,SIGNAL(rejoindre(QString)),this,SLOT(creationchan(QString)));
    connect(w,SIGNAL(oexp( Q_UINT16)),this,SLOT(dlliste( Q_UINT16)));
}

void MainWin::dlliste( Q_UINT16 uid)
{
    net->getFileList(uid);
    openTransferts();
}


void MainWin::recvliste(const QString &file)
{
    userFileBrowser * browser = new  userFileBrowser(file,wrk,"browser", WDestructiveClose);
    browser->show();
}


void MainWin::hidedockwin(bool b)
{
    if (b)
	dockwin.setFixedExtentWidth(5);
    else
	dockwin.setFixedExtentWidth(235);
}



void MainWin::rcvmsg(Q_UINT16 uid,const QString &sender,const QString& msg )
{
    QString caption = tr("Conversation")+" - "+sender;
    pvmsg * w;

    if (!(w = (pvmsg  *)isOpen(caption)))
    {
	w = new pvmsg (wrk,0,WDestructiveClose);
	connect(this,SIGNAL(updateConf()),w,SLOT(applyUpdateConf()));
	connect(w,SIGNAL(updateConf()),this,SLOT(sendUpdateConf()));
	w->setId(uid);
	w->rcvmsg(uid,sender,msg);
	w->show();
    }
}

void MainWin::openpvmsg(QString cap,Q_UINT16 uid)
{
    QString caption = tr("Conversation")+" - "+cap;
    pvmsg * w;

    if (!(w = (pvmsg  *)isOpen(caption)))
    {
	w = new pvmsg (wrk,0,WDestructiveClose);
	connect(this,SIGNAL(updateConf()),w,SLOT(applyUpdateConf()));
	connect(w,SIGNAL(updateConf()),this,SLOT(sendUpdateConf()));
	w->setId(uid);
	w->show();
    }
    else
	w->setFocus();
}



void MainWin::hideo()
{
	hide();
    tray->disconnect();
    QObject::connect(tray,SIGNAL(clicked( const QPoint&,int )),this,SLOT(showo()));
}


void MainWin::showo()
{
    if(gconf->isMaximized())
		showMaximized();
    else
		showNormal();
    setActiveWindow();
    tray->disconnect();
    QObject::connect(tray,SIGNAL(clicked( const QPoint&,int )),this,SLOT(hideo()));
}


bool MainWin::event ( QEvent * e )
{
    if(e->type()==QEvent::WindowStateChange )
    {
		gconf->setIsMaximized(isMaximized());
		if (isVisible() && isMinimized())
		{
			hideo();
			return TRUE;
		}
    }
	return QMainWindow::event(e);
}

void MainWin::openKeyRequest(Q_UINT16 uid)
{
   if(!(QMessageBox::question(this, tr("Demande de cl par "+ (net->GetGraph()->nodes(uid).name)),tr("Un utilisateur demande votre cl publique. Voulez vous lui envoyer?"),tr("Oui"), tr("Non"), QString::null, 0, 1 )))
	    net->sendPublicKey(uid);
}


void MainWin::openGiveRequest(QString nodeid,QString key)
{
    if(!(QMessageBox::question(this, tr("Demande de cl "+ (net->GetGraph()->nodes(net->GetGraph()->NodeidToId(nodeid)).name)),tr("Un utilisateur demande votre cl publique. Voulez vous lui envoyer?"),tr("Oui"), tr("Non"), QString::null, 0, 1 )))
    {
	acceptgive(nodeid,key);
    }
}


void MainWin::acceptgive(QString nodeid, QString key)
{
    if(gconf->pubKey(nodeid) == QString::null)
	gconf->addPubKey(nodeid,key);
}

void MainWin::updateConfWebserver()
{
    if(!httpd  && !gconf->webActivated())
	return;
    if(!httpd && gconf->webActivated())
	httpd = new GWebServer(gconf->webPassword(), gconf->webListenPort());
    else if(httpd && !gconf->webActivated())
    {
	delete httpd;
	httpd = NULL;
    }
    else
    {
	delete httpd;
	httpd = new GWebServer(gconf->webPassword(), gconf->webListenPort());
    }
}


void MainWin::init()
{
    gconf->setMainWindowPointer(this);
    nbusers = 1;
    wrk = new QWorkspace(this);
    wrk->setScrollBarsEnabled( TRUE );
    setDockEnabled(Qt::DockRight,TRUE);
    setCentralWidget(wrk);
    setIcon(QPixmap::fromMimeSource("Gloster.png"));

    createToolBars();
    createnetwork();
    openlstcnt();
    openTransferts();
    createdockwin();
    refreshSharedFiles();
    openConnect();
    initStatusBar();

    //Connexions avec le gconfig - application de certains parametres a la volee
    connect(gconf,SIGNAL(updateConfWebserver()),this,SLOT(updateConfWebserver()));
    connect(gconf,SIGNAL(updateConfTextUnderIcons(bool)),this,SLOT(setUsesTextLabel(bool)));

    connect((QObject *)(Fenetres),SIGNAL(aboutToShow ()),SLOT(UpdateMenu()));
    
    //Connexion avec le GNetwork
    connect(net,SIGNAL(recvFileList(const QString &)),this,SLOT(recvliste(const QString &)));
    if (gconf->autoAcceptKey())
    {
	connect(net,SIGNAL(recvKeyRequest(Q_UINT16)),net,SLOT(sendPublicKey(Q_UINT16)));
	connect(net,SIGNAL(recvGiveKey(QString,QString)),this,SLOT(acceptgive(QString,QString)));
    }
    else
    {
	connect(net,SIGNAL(recvKeyRequest(Q_UINT16)),this,SLOT(openKeyRequest(Q_UINT16)));
	connect(net,SIGNAL(recvGiveKey(QString,QString)),this,SLOT(openGiveRequest(QString,QString)));
    }
    connect(net,SIGNAL(newNode(Q_UINT16, const QString&,t_connexion)),this, SLOT(adduser(Q_UINT16, const QString&,t_connexion)));
    connect(net,SIGNAL(delNode(Q_UINT16)),this, SLOT(deluser(Q_UINT16)));
    
    loadWindowState();
    show();
}

void MainWin::saveWindowState()
{
    qWarning("Sauvegarde de la position de la fentre");
    gconf->setXPos(pos().x());
    gconf->setYPos(pos().y());
    gconf->setWSize(size().width());
    gconf->setHSize(size().height());
    gconf->setIsMaximized(isMaximized());
}


void MainWin::loadWindowState()
{
    move(gconf->xPos(),gconf->yPos());
    resize(gconf->wSize(),gconf->hSize());
    setWindowState(Qt::WindowActive | (gconf->isMaximized()?(Qt::WindowMaximized):(Qt::WindowNoState)));
}

void MainWin::activateNextWindow()
{
    wrk->activateNextWindow();
    while(wrk->activeWindow()->isHidden())
	wrk->activateNextWindow();
}


void MainWin::activatePrevWindow()
{
    wrk->activatePrevWindow();
    while(wrk->activeWindow()->isHidden())
	wrk->activatePrevWindow();
}


void MainWin::closeActiveWindow()
{
    wrk->activeWindow()->close();
}


void MainWin::closeAllWindows()
{
    QWidgetList windows = wrk->windowList(QWorkspace::CreationOrder);
    for (int i = 0; i <int(windows.count()); i++)
	windows.at(i)->close();
}


void MainWin::updateTaskBar()
{
    QWidget * w;
    QPushButton * button;
    QWidgetList windows = wrk->windowList(QWorkspace::CreationOrder);

    taskBar->clear();

    bg = new QButtonGroup(taskBar,"taskBar buttonGroup");
    taskBar->setWidget(bg);
    bg->setExclusive(TRUE);
    connect(bg,SIGNAL(clicked(int)),this,SLOT(setTaskBarWindowFocus(int)));

    for (int i = 0; i <int(windows.count()); ++i)
    {
	w =windows.at(i);
	if(!w->isHidden())
	{
	    button = new QPushButton(taskBar);
	    button->setToggleButton(TRUE);
	    button->setFlat(TRUE);
	    button->setText(w->caption());
	    if(w == wrk->activeWindow() || !wrk->activeWindow() || wrk->activeWindow()->isHidden())
		button->setOn(TRUE);
	    bg->insert(button,i);
	}
    }
}


void MainWin::setTaskBarWindowFocus(int id)
{
    QWidgetList windows = wrk->windowList(QWorkspace::CreationOrder);
    windows.at(id)->setFocus();
}


void MainWin::updateSpeedRatesBar(double dw, double up)
{
    dwlbl->setText(tr("Rc.")+" : "+QString::number(dw)+" Ko/s");
    uplbl->setText(tr("Env.")+" : "+QString::number(up)+(!gconf->conSpeed()?"":"/"+QString::number(gconf->conSpeed())+".0")+" Ko/s");
}


void MainWin::sendUpdateConf()
{
    emit updateConf();
}


void MainWin::adduser( Q_UINT16, const QString &, t_connexion )
{
    nbusers += 1;
    nbuserslbl->setText(" "+QString::number(nbusers)+" "+tr("utilisateurs")+" ");
}


void MainWin::deluser( Q_UINT16 )
{
    nbusers -= 1;
    if(nbusers == 1)
	nbuserslbl->setText(" "+QString::number(nbusers)+" "+tr("utilisateur")+" ");
    else
	nbuserslbl->setText(" "+QString::number(nbusers)+" "+tr("utilisateurs")+" ");
}


void MainWin::aboutToQuit()
{
	shareFileBrowserWindow *w;

	if ((w = (shareFileBrowserWindow *) isOpen(tr("Fichiers partags"))))
		delete(w);
	saveWindowState();
}
