/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qmessagebox.h>
#include "../network/gnetwork.h"
#include "../graphes.h"
#include "../gdate.h"
#include "connex.h"
#include "fontdialog.h"
#include "mainwin.h"

extern GNetwork *net;
extern c_graphes * graphe;

void pvmsg::send()
{
   if (!(msg->text()).isEmpty ())
    {

      if (msg->text().section(' ',0,0)=="/me")
        {
          QColor color(0,0,100);
          discuss->setColor(color);
          discuss->setBold(1);
          net->sendChatPv( id,myStyle+";"+msg->text());
          discuss->append("*** "+gconf->nickname()+" "+msg->text().section(' ',1).simplifyWhiteSpace()+" ***");
          msg->clear();
          msg->setFocus();
        }
      else
        {
          if (gconf->isChatTimeStamp())
            discuss->append(GDate::timestamp()+"<b>"+gconf->nickname()+" "+tr("dit")+ " : </b>");
          else
            discuss->append("<b>"+gconf->nickname()+" "+tr("dit")+ " : </b>");
          applyUserStyle(myStyle);
          net->sendChatPv( id,myStyle+";"+msg->text());
          discuss->append(msg->text());
          msg->clear();
          msg->setFocus();
        }
    }
}

void pvmsg::rcvmsg(Q_UINT16 uid, const QString& sender, const QString& mg)
{
  if (uid==id)
    {

      if (mg.section(";",4,4).section(' ',0,0)=="/me")
        {
          QColor color(0,0,100);
          discuss->setColor(color);
          discuss->setBold(1);
          discuss->append("*** "+sender+" "+mg.section(";",4,4).section(' ',1).simplifyWhiteSpace()+" ***");
        }
      else
        {
          if (gconf->isChatTimeStamp())
            discuss->append(GDate::timestamp()+"<b>"+sender +" "+tr("dit")+ " : </b>");

          else
            discuss->append("<b>"+sender +" "+tr("dit")+ " : </b>");
          qWarning(mg.section(";",0,3));
          applyUserStyle(mg.section(";",0,3));
          discuss->append(mg.section(";",4,4));
        }
    }
  if(hasFocus())
    msg->setFocus();
}

void pvmsg::onDisconnect(Q_UINT16 uid)
{
    if (uid==id)
    {
	discuss->append("<hr><b>"+tr("Le contact est dconnect")+"</b>");
	deactivateWindow();
    }
}


void pvmsg::setId( int uid )
{
    id = uid;
    setCaption(tr("Conversation") + " - " + graphe->nodes(id).name);
}


void pvmsg::init()
{
    setIcon(QPixmap::fromMimeSource("chat.png"));
    applyUpdateConf();
    msg->setFocus();

    connect(net,SIGNAL(recvChatPv(Q_UINT16, const QString&, const QString&)),this,SLOT(rcvmsg(Q_UINT16,const QString&, const QString&)));
    connect(net,SIGNAL(delNode(Q_UINT16)),this,SLOT(onDisconnect(Q_UINT16)));
    connect(net,SIGNAL(newNode(Q_UINT16)),this,SLOT(onConnect(Q_UINT16)));
}



void pvmsg::openFontOptions()
{
    fontdialog * w = new fontdialog(this, 0, false, WDestructiveClose);
    connect(w, SIGNAL(updateConf()), this, SLOT(sendUpdateConf()));
    w->show();
}


void pvmsg::blockUser()
{
    if ((QMessageBox::question(this, tr("Bloquer les messages de cet utilisateur"),tr("Etes vous sur de vouloir bloquer tous les messages provenant de cet utilisateur ?"), tr("Non"),tr("Oui"), QString::null, 0, 1 )))
    {
	graphe->setBlocked(id,TRUE);
	discuss->append("<hr><b>"+tr("Vous avez bloqu ce contact. Pour lui parler  nouveau, cliquez sur le bouton 'dbloquer'")+"</b>");
	btnblockstack->raiseWidget(1);
	deactivateWindow();
    }
}


void pvmsg::sendUpdateConf()
{
    emit updateConf();
}


void pvmsg::applyUpdateConf()
{
    myStyle  = QString::number(gconf->chatTextColor().red());
    myStyle += ";";
    myStyle += QString::number(gconf->chatTextColor().green());
    myStyle += ";";
    myStyle += QString::number(gconf->chatTextColor().blue());
    myStyle += ";";
    myStyle += gconf->isChatTextBold()?"1":"0";
    myStyle += gconf->isChatTextItalic()?"1":"0";
    myStyle += gconf->isChatTextUnderlined()?"1":"0";
    msg->setColor(gconf->chatTextColor());
    msg->setBold(gconf->isChatTextBold());
    msg->setItalic(gconf->isChatTextItalic());
    msg->setUnderline(gconf->isChatTextUnderlined());
}


void pvmsg::onConnect( Q_UINT16 uid )
{
    if (uid==id)
    {
	discuss->append("<hr><b>"+tr("Le contact est  nouveau en ligne")+"</b><hr>");
	activateWindow();
    }
}


void pvmsg::applyUserStyle( const QString& style )
{
    QColor color(style.section(';',0,0).toInt(),style.section(';',1,1).toInt(),style.section(';',2,2).toInt());
    QString font = style.section(';',3,3);
    discuss->setColor(color);
    discuss->setBold(font.left(1).toInt());
    discuss->setItalic(font.mid(1,1).toInt());
    discuss->setUnderline(font.right(1).toInt());
}


void pvmsg::unblockUser()
{
	graphe->setBlocked(id,FALSE);
	discuss->append("<hr><b>"+tr("Vous venez de dbloquer ce contact. Vous pouvez parler avec lui  nouveau.'")+"</b><hr>");
	btnblockstack->raiseWidget(0);
	activateWindow();
}


void pvmsg::activateWindow()
{
    if(!graphe->isBlocked(id))
    {
	sndbtn->connect(sndbtn,SIGNAL(clicked()),this,SLOT(send()));
	sndbtn->setEnabled(TRUE);
	msg->setEnabled(TRUE);
	fontOptionsbtn->setEnabled(TRUE);
	blockbtn->setEnabled(TRUE);
    }
}


void pvmsg::deactivateWindow()
{
    sndbtn->disconnect(sndbtn,SIGNAL(clicked()),0,0);
    sndbtn->setEnabled(FALSE);
    msg->setEnabled(FALSE);
    fontOptionsbtn->setEnabled(FALSE);
    blockbtn->setEnabled(FALSE);
}


bool pvmsg::event( QEvent * e )
{
    bool b;
    QEvent::Type t = e->type();
    b = QWidget::event(e);
    if( t == QEvent::LanguageChange)
	setCaption(tr("Conversation") + " - " + graphe->nodes(id).name);
    return b;
}
