/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qbitarray.h>
#include <qvaluelist.h>
#include <qpopupmenu.h>
#include <qmessagebox.h>
#include "../network/gnetwork.h"
#include "../files/gdownloader.h"
#include "../files/gfileconst.h"
#include "../gtypes.h"

extern GNetwork *net;

Q_UINT64 transferts::alreadydl(QBitArray &part,Q_UINT64 filesize)
{
    unsigned int i=0;
    int res=0;
    
    if (part.size()>2)
    {
	while(i<=part.size()-2)
	{
	    res=res+part[int(i)];
	    i++;
	}
    }  
    res=res*PART_SIZE;
    if (part[int(part.size()-1)])
    {
	if (filesize % PART_SIZE)
	    res=res+(filesize % PART_SIZE);
	else
	    res=res+PART_SIZE;
	
    }
    return res;
}



void transferts::startdown(const QString &filename,Q_UINT64 filesize,const QString &hash,QBitArray &part)
{
    QListViewItem* lv;
    unsigned int dlsize=alreadydl(part,filesize);
    unsigned int dl;
    dl=dlsize*100/filesize;
    lv = new QListViewItem(dllst,filename,QString::number(dl)+" %",QString::number(dlsize),QString::number(filesize),hash);    
}



void transferts::updatedl(Q_UINT64 filesize,const QString& hash,Q_UINT64 received,const QValueList<GSrcSpeed>& srclist)
{
    QListViewItem* liste=dllst->firstChild();
    QListViewItem* lv;
    Q_UINT64 dlsize;
    Q_UINT64 dlpercent;
    int sources=0;
    unsigned long int sp=0;
    QValueList<GSrcSpeed>::const_iterator it;
    
    while ((liste) &&  (liste->text(3)!=QString::number(filesize)) && (liste->text(4)!=hash))
	liste=liste->nextSibling();      
    
    
    if (liste)
    {		
	dlsize=liste->text(2).toUInt();
	for (it =srclist.begin(); it !=srclist.end();++it )
	{
	    sources++;
	    lv = new QListViewItem(liste,(*it).nodeId,"","","","",QString::number((*it).speed/1024));
	    sp=sp+ ((*it).speed); 
	}
	
	dlsize=dlsize+received;
		
	dlpercent=dlsize*100/(filesize);
	
	if (dlpercent==100)
	    liste->setText(1,tr("Finalisation")); 
	else
	    liste->setText(1,QString::number(dlpercent)+" %"); 
	
	liste->setText(2,QString::number(dlsize));  
	liste->setText(5,QString::number(sp/1024));  
	liste->setText(6,QString::number(sources)); 
    }	
}


void transferts::finished(Q_UINT64 filesize,const QString &hash)
{
    QListViewItem* liste=dllst->firstChild();   
    
    while ((liste) &&  (liste->text(2)!=QString::number(filesize)) && (liste->text(4)!=hash))
	liste=liste->nextSibling();  
    
    if (liste)
    {
	liste->setText(1,"100 %");
	liste->setText(2,tr("Termin"));
    }    
}


void transferts::showmenu(QListViewItem *it,const QPoint &p,int)
{
    QPopupMenu *menu = new QPopupMenu(dllst,"menu");
    menu->insertItem(tr("Annuler"),this,SLOT(cancel()),0,0);
    menu->insertItem(tr("Supprimer"),this,SLOT(del()),0,1);
 
    if (it)
    {
	menu->setItemEnabled(0,it->text(2)!=tr("Termin")); 
	menu->insertSeparator();
    }
    else
    {
	menu->setItemVisible(0,FALSE); 	
	menu->setItemVisible(1,FALSE); 
    }
    
    menu->insertItem(tr("Effacer les termins"),this,SLOT(clearCompleted()),0,2);
    menu->insertItem(tr("Effacer les annuls"),this,SLOT(clearCanceled()),0,5);
    menu->insertSeparator();
    menu->insertItem(tr("Annuler tout"),this,SLOT(cancelAll()),0,3);
    menu->insertItem(tr("Tout supprimer"),this,SLOT(deleteAll()),0,4);
    if(!dllst->childCount())
    {
	menu->setItemEnabled(2,FALSE);
	menu->setItemEnabled(3,FALSE);
	menu->setItemEnabled(4,FALSE);
	menu->setItemEnabled(5,FALSE);
    }
    
    menu->exec(p);  
}

//Supprime les items selectionnes et annule les dl s'ils sont en cours avant de les deleter
void transferts::del()
{
    QListViewItem* item=dllst->firstChild();   
    QListViewItem* temp;
 
    while (item)
    {      
	if(item->isSelected())
	{
	    if(item->text(2)!=tr("Termin") && item->text(2)!=tr("Annul"))
		net->cancel(item->text(3).toUInt(),item->text(4));
	    temp = item;
	    item=item->nextSibling();  
	    delete temp;
	    continue;
	}
	item=item->nextSibling();  
    }
}

//Supprime tous les item ayant l'etat passe en parametre
void transferts::clearState(const QString& state)
{
    QListViewItem* liste=dllst->firstChild();   
    QListViewItem* lst;
 
    while (liste)
    {      
	if(liste->text(2)==state)
	{
	    lst=liste;
	    liste=liste->nextSibling();  
	    delete lst;
	}
	else
	    liste=liste->nextSibling();  
    }
}


void transferts::pause()
{   
    net->downloader->pause(dllst->selectedItem()->text(3).toUInt(),dllst->selectedItem()->text(4));  
}

void transferts::resume()
{
    net->downloader->resume(dllst->selectedItem()->text(3).toUInt(),dllst->selectedItem()->text(4));    
}


void transferts::cancel()
{
    QListViewItem * item = dllst->firstChild();
    while(item)
    {
	if(item->isSelected())
	    cancelDlItem(item);
	item = item->nextSibling();
    }
}

void transferts::incomming(const QString &)
{
    /*   qDebug("ID dU NODE= "+nodeid);
	 
   QListViewItem* lv;
    lv = new QListViewItem(ullst,nodeid,"","En cours"); */
}

void transferts::askingul(Q_UINT64 fsize, const QString &hash, const QString &fname, const QString &nodename)
{
    QListViewItem* lv;
    
    lv= new QListViewItem(ullst,nodename,fname,tr("Demande"),QString::number(fsize),"0",hash);
    
}

void transferts::startul(Q_UINT64 fsize, const QString &hash, const QString &nodename, unsigned long int speed)
{
    QListViewItem* liste=ullst->firstChild();
    
    
    while ((liste) &&  (liste->text(0)!=nodename) && (liste->text(5)!=hash))
	liste=liste->nextSibling();  
    if (liste)
    {
	liste->setText(4,QString::number(speed/1024));
	liste->setText(2,"Connect");
	liste->setText(3,QString::number(fsize));
    }
    
}


void transferts::endconnection(const QString &hash, Q_UINT64 fsize, const QString &nodename)
{
    
    QListViewItem* liste=ullst->firstChild();
    
    while ((liste) &&  (liste->text(5)!=hash) && (fsize!=liste->text(3)) && (nodename!=liste->text(0)))
	liste=liste->nextSibling();  
    if (liste)
	liste->setText(2,tr("Fin de transfert"));
}


void transferts::closeEvent ( QCloseEvent * e )
{
    hide();
    e->ignore();
}

void transferts::init()
{
    setIcon(QPixmap::fromMimeSource("transferts.png"));
    ullst->setAllColumnsShowFocus( TRUE );
    dllst->setAllColumnsShowFocus( TRUE );
    
    connect(net->downloader,SIGNAL(tempLoaded(const QString &,Q_UINT64,const QString &,QBitArray &)),this,SLOT(startdown(const QString &,Q_UINT64,const QString&,QBitArray&)));
    connect(net->downloader,SIGNAL(finished(Q_UINT64,const QString &)),this,SLOT(finished(Q_UINT64,const QString &)));
    connect(net->downloader,SIGNAL(downloadSpeed(Q_UINT64,const QString& ,Q_UINT64,const QValueList<GSrcSpeed>&)),this,SLOT(updatedl(Q_UINT64,const QString& ,Q_UINT64,const QValueList<GSrcSpeed>&)));
    connect(net->uploader,SIGNAL(connection(const QString &)),this,SLOT(incomming(const QString &)));
    connect(net->uploader,SIGNAL(Transferring(Q_UINT64 , const QString &, const QString &, unsigned long int)),this,SLOT(startul(Q_UINT64 , const QString &, const QString &, unsigned long int)));		                                                   
    connect(net->uploader,SIGNAL(askingFile(Q_UINT64, const QString &, const QString &, const QString &)),this,SLOT(askingul(Q_UINT64, const QString &, const QString &, const QString &)));
    connect(net->uploader,SIGNAL(connectionLost(const QString &, Q_UINT64, const QString &)),this,SLOT(endconnection(const QString &, Q_UINT64, const QString &)));
}


void transferts::clearCompleted()
{
    clearState(tr("Termin"));
}


void transferts::clearCanceled()
{
    clearState(tr("Annul"));
}


void transferts::cancelAll()
{
    if((QMessageBox::question(this, tr("Annulation de tous les tlchargements"),tr("Etes vous sur de vouloir annuler tous les tlchargement en cours ?"), tr("Non"),tr("Oui"), QString::null, 0, 1 )))
    {
	QListViewItem * item = dllst->firstChild();
	while(item)
	{
	    if(item->text(2)!=tr("Termin") && item->text(2)!=tr("Annul"))
		cancelDlItem(item);
	    item=item->nextSibling();
	}
    }
}


void transferts::deleteAll()
{
    if((QMessageBox::question(this, tr("Suppression de tous les tlchargements"),tr("Etes vous sur de vouloir supprimer tous les tlchargement ?"), tr("Non"),tr("Oui"), QString::null, 0, 1 )))
    {
	QListViewItem* item=dllst->firstChild();   
	QListViewItem* temp;
	
	while (item)
	{      
	    if(item->text(2)!=tr("Termin") && item->text(2)!=tr("Annul"))
		net->cancel(item->text(3).toUInt(),item->text(4));
	    temp = item;
	    item=item->nextSibling();  
	    delete temp;
	}
    }
}

void transferts::cancelDlItem( QListViewItem * item )
{
    item->setText(2,tr("Annul"));  
    net->cancel(item->text(3).toUInt(),item->text(4));
}
