/***************************************************************************
 *            gfilesocket.h
 *
 *  Thu May  5 11:42:12 2005
 *  Copyright  2005  CrYpToNyM
 *  Email
 ****************************************************************************/

#ifndef _GFILESOCKET_H
#define _GFILESOCKET_H

#include <../crypt/gcryptsocket.h>
#include <qbitarray.h>
#include <qcstring.h>
#include "gfilesocketcommon.h"


class GTempFile;

class GFileDlSocket : public QObject
{
    Q_OBJECT

	public:
		GFileDlSocket(Q_UINT16 uid,const QString &nodeid,const QString &hash, Q_UINT64 fsize,QObject * parent = 0, Q_UINT64=0, const char * name = 0);
		GFileDlSocket(const QString &hash, Q_UINT64 fsize,QObject * parent = 0, Q_UINT64 rsize=0,  const char * name = 0);
		~GFileDlSocket();

		Q_UINT16 uId();
		const QString & nodeId();
		void setSocket(GCryptSocket *s);
		void close();
		void getPart(Q_UINT16 chunk, unsigned char part);
		void sendGet(const QString &hash, unsigned long long fsize);
        Q_UINT16 dist_uid;
		bool ok;

		unsigned long int written;


	signals:
		void haventFile();
		void newPart(Q_UINT16 chunk, unsigned char part, QByteArray &dat);
		void recvFileInf(QStringList chunkhashes, QBitArray &chunks);
		void newChunkSource(Q_UINT16 chunk);
		void inQueue(unsigned short int pos);
		void unableToConnect();
		void sockClose();
                void NeedKey(Q_UINT16 uid);

	private slots:
//		void onWritten( int );
		void handShakeFilter();
		void transferFilter();
		void onError(int);
		void onClose();
		void onConnect();

	private:
		GCryptSocket *socket;
		PartPosQueue part_queue;
		Q_UINT64 filesize,realsize;
		QString hash;
		QString nodeid;
		unsigned long int remaining,size,nbchunk;
		QByteArray dat;
		QBitArray chunks;


		QString ip;
		Q_UINT16 port;

	friend class GTempFile;
};


#endif /* _GFILESOCKET_H */
