/***************************************************************************
 *            gfileulsocket.h
 *
 *  Thu May  5 20:57:50 2005
 *  Copyright  2005  CrYpToNyM
 *  Email
 *
 *  Appeller inQueue ou sendFileInf pendant le transfert peut couper la connex
 *  Il donc est fortement recommande de ne pas faire de la merde
 ****************************************************************************/

#ifndef _GFILEULSOCKET_H
#define _GFILEULSOCKET_H

#include <../crypt/gcryptsocket.h>
#include <qstring.h>
#include <qfile.h>
#include <qbitarray.h>
#include <qcstring.h>
#include <qtimer.h>
#include "gfilesocketcommon.h"

union t_len{
	Q_UINT64 val;char c[8];
};

class GFileUlSocket : public QObject
{
    Q_OBJECT

	public:
		GFileUlSocket(const char *nodeid, const QString &ip, Q_UINT16 port, QObject * parent = 0, const char * name = 0);
		GFileUlSocket(const char *nodeid, GCryptSocket* s,QObject * parent = 0, const char * name = 0);
		~GFileUlSocket();
		void start();
		void close();
		unsigned long int getMaxSpeed();
		void setMaxSpeed(unsigned long int s);
		unsigned long int written;
		QString nodeId();
		const QString &nodeName();
		//Pas tres joli mais optimise
		int index,file_index;
                Q_UINT16 dist_uid;

	public slots:
		void sendHi();
		void sendPart(const QByteArray &data);
		void sendFileInf(const char *chunkhashes,const QBitArray &chunks);
		void newChunk(Q_UINT16 chunk);
		void inQueue(Q_UINT16 pos);

	signals:
		void newPart(unsigned int chunk, unsigned char part);
		void askingFile(const char *hash,Q_UINT64 size);
		//void askingList(const char *nodeid);
		void sockClose();
                void NeedKey(Q_UINT16 uid);

	private slots:
		void handShakeFilter();
		void transferFilter();
		void sendData();
		void onWriteNoLimit(int b);
		void onClose();
		void onWritten( int );

	private:
		GCryptSocket *socket;
		QTimer *timer;
		PartPosQueue part_queue;
		t_len filesize;
		unsigned long int byte_per_tick;
		unsigned long int remaining;
		QByteArray dat;
		char distantNodeID[NODE_ID_SIZE], hash[MD5_DIGEST_LENGTH];
		QString name;

};


#endif /* _GFILEULSOCKET_H */
