/***************************************************************************
 *            gipaddr.cpp
 *
 *  Thu Jun 16 13:08:47 2005
 *  Copyright  2005  CrYpToNyM
 *  Email
 ****************************************************************************/

#include <qhostaddress.h>

#include "gipaddr.h"


GIpAddr::GIpAddr(QObject * parent,const char * name) //constructor
	: QObject( parent, name )
{
	s=new QSocket(this);
	connect(s,SIGNAL(connected()),this,SLOT(socketConnected()));
	connect(s,SIGNAL(readyRead()),this,SLOT(socketData()));
	
	s->connectToHost("www.edpsciences.com",80);
}

GIpAddr::~GIpAddr()                        //destructor
{
	delete s;
}

bool GIpAddr::isValidIP(const QString &ip)
{
	QHostAddress a;
	return (ip!="" && a.setAddress(ip) && ip!="127.0.0.1" && ip!="0.0.0.0");
}

void GIpAddr::socketConnected()
{
	if (isValidIP(s->address().toString()))
		emit lanIP(s->address().toString());
	QString dat="GET http://www.edpsciences.com/htbin/ipaddress HTTP/1.0\n\n";
	s->writeBlock(dat.latin1(),dat.length());
}

void GIpAddr::socketData()
{
	char data[1024];
	QString ip;
	data[s->readBlock(data,1023)]=0;
	s->close();
	ip=data;
	ip=ip.section("<B> ",-1,0xffffffff, QString::SectionCaseInsensitiveSeps);
	ip=ip.section(" </B>",0,0, QString::SectionCaseInsensitiveSeps);
	if (isValidIP(ip))
		emit internetIP(ip);
}
