/***************************************************************************
 *            gsocket.h
 *
 *  Sun Jan  2 18:39:43 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _GSOCKET_H
#define _GSOCKET_H

#include <qsocket.h>
#include <qstring.h>
#include "../gtypes.h"
#include "../graphes.h"
#include "../crypt/gcryptsocket.h"


class GSocket : public QObject
{
    Q_OBJECT
	public:
		GSocket(class GCryptSocket *s,class c_graphes *g=0,QObject * parent = 0, const char * name = 0);
		GSocket(QObject * parent = 0, class c_graphes *graph=0, const char * name = 0);
		~GSocket();

		QString peerName() const;
		Q_UINT16 peerPort();
		void writeLine(const QString &line);

		QString readCryptedLine();
		void writeCryptedLine(const QString &line);
		void connectIncomingFilter();


		unsigned short int GetID()
		{
			return id;
		}

	public slots:
		void connectToHost(const QString &ip, Q_UINT16 port);
		void close();

	private:
		bool isNewStar(const QString &nodeid,unsigned char starcount);

		class c_graphes *graph;
		QString peerN;
		Q_UINT16 peerP;
		unsigned short int id;
		GCryptSocket *socket;

	private slots:
		void onConnect();
		void discardClient();
		void discardClientErr(int);

		void handshakeIncomingPacketFilter();
		void handshakeOutcomingPacketFilter();
		void packetFilter();

	 	void handshakeHello();
		void handshakeAccepted();

	signals:
		void connected();
		void connectionClosed();

		void routePacket(const QString &packettype,const QString &senderid, Q_UINT16 *destids,Q_UINT16 nbdest,const QString &data );

		void ConnectStar();

		void wantKeyAsk(unsigned short int from);
		void wantKeyAns(unsigned short int from, char *key);

		void recvStar(QStringList &star);
		void recvChanStar(Q_UINT16 node, QStringList &chanstar);

		void recvChatUserEvent(Q_UINT16 user, const QString &channame, bool Connection);
		void recvChatMsg(const QString &sender, const QString &channame, const QString &msg);
		void recvChatPv(Q_UINT16 node,const QString &sender, const QString &msg);
		void recvSearchByName(Q_UINT16 from, const QString &name, unsigned int type);
		void recvSearchByNameAns(Q_UINT16 from, const QString &srchstr, const QStringList &filelist);
		void recvSearchByHash(unsigned short int from, const QString &hash, Q_UINT64 size);
		void recvSearchByHashAns(unsigned short int from, const QString &hash, Q_UINT64 size, const QString &filename);

		void recvFileList(Q_UINT16 uid);
		void recvFileListHash(Q_UINT16 uid, Q_UINT64 size, const QString &hash);
		void recvAskConnect(Q_UINT16 uid);

                void recvKeyRequest(Q_UINT16 uid);
                void recvGiveKey(QString nodeid, QString key);

		void newNode(Q_UINT16 uid);

/*

		void ChatEventRecv(unsigned short int from, QString chan, QString event);
		void FileListAsk(unsigned short int from);
		void FileListRecv(unsigned short int from, char *dat); // penser a definir le type de la file list d un user (fichier...?)
		void ChatPvRecv(unsigned short int from, QString msg);
		void DatAsk(unsigned short int from, char *dat);
		void DataAns(unsigned short int from, char *dat);
		void KeyExchangeRecv(unsigned short int from, char *dat);*/
};


#endif //_GSOCKET_H
