/***************************************************************************
 *            rfc_gloster.cpp
 *
 *  Mon Feb 28 12:39:59 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "rfc_gloster.h"

const QString RFC_HELO = QString("HELO");
const QString RFC_ACPT = QString("ACPT");

const QString RFC_UNKN = QString("UNKN");
const QString RFC_WRNG = QString("WRNG");

const QString RFC_STAR = QString("STAR");

const QString RFC_CUEV = QString("CUEV");
const QString RFC_CMSG = QString("CMSG");
const QString RFC_CMPV = QString("CMPV");

/* Recherche par nom
* SRCH ... 8 toto
*        type chaine
* RSRH ... toto tata_toto.avi 654258 AF5848BC7 2;titi_toto.exe 89789 E8CD48 1
*           id   nom fichier  taille   hash    type
*/
const QString RFC_SRCH = QString("SRCH");
const QString RFC_RSRH = QString("RSRH");
/* Recherche par hash
*	HSRH ... AF5848BC7 654258
*	           hash    taille
*	HRSR ... AF5848BC7 654258 tata_toto.avi
*	           hash    taille nom du fichier
*/
const QString RFC_HSRH = QString("HSRH");
const QString RFC_HRSR = QString("HRSR");

/* Liste de fichiers - unicast
* FLST ...
* RFLS ... AF5848BC7 654258
*             hash   taille
*/
const QString RFC_FLST = QString("FLST");
const QString RFC_RFLS = QString("RFLS");

/* Demander une connexion directe (si on est en passif) - unicast
* ACON ...
*/
const QString RFC_ACON = QString("ACON");

const QString RFC_QUIT = QString("QUIT");


/* Echange de cles
* WKEY ...
* GKEY ... a6ff7b5a8e42cf55a8c
*             cle publique
*/
const QString RFC_WKEY = QString("WKEY");

const QString RFC_GKEY = QString("GKEY");


/*
 *	Expressions regulieres de filtrage
 */
const QRegExp reHandShakeHELO("HELO \\w{1,15} \\w{25} [1-8] (((([0-1]?\\d)|(2[0-4]))?\\d)|(25[0-5])) ((\\w|.){3,}) (([0-9]){1,5}) (((([0-1]?\\d)|(2[0-4]))?\\d)|(25[0-5]))"); //HELO Nickname NodeID Conntype Connspeed Hostname ListenPort
const QRegExp reHandShakeACPT("ACPT \\w{1,15} \\w{25} [1-8] (((([0-1]?\\d)|(2[0-4]))?\\d)|(25[0-5])) ((\\w|.){3,}) (([0-9]){1,5}) (((([0-1]?\\d)|(2[0-4]))?\\d)|(25[0-5]))");

const QRegExp rePacketRouting("\\w{4} \\w{25} (\\w{25},)*\\w{25}.*");

const QRegExp reUNKN(RFC_UNKN+"( .*)?");
const QRegExp reWRNG(RFC_WRNG+"( .*)?");
